<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'my_report_tracker' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package core.map
 */
class MyReportTrackerMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "core.map.MyReportTrackerMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("my_report_tracker");
		$tMap->setPhpName("MyReportTracker");
		
         
		$tMap->setUseIdGenerator(false);
		 
						
		 
		
		// Add columns to map
		$tMap->addForeignPrimaryKey("MY_REPORT_ID", "MyReportId", "int" , CreoleTypes::INTEGER, "my_report", "MY_REPORT_ID", true);
		$tMap->addForeignPrimaryKey("TRACKER_ID", "TrackerId", "int" , CreoleTypes::INTEGER, "tracker", "TRACKER_ID", true);
				
    }
}
