<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';

include_once 'core/ThemePeer.php';

/**
 * Base class that represents a row from the 'theme' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Theme class. 
 * 
 * @package core 
 */
abstract class BaseTheme extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var ThemePeer
	 */
	protected static $peer;

	/**
	 * The value for the theme_id field.
	 * @var int	  
	 */
	protected $theme_id;	

	/**
	 * The value for the dirname field.
	 * @var string	  
	 */
	protected $dirname;	

	/**
	 * The value for the fullname field.
	 * @var string	  
	 */
	protected $fullname;	
  
	/**
	 * Get the ThemeId column value.
	 *  
	 * @return int	  
	 */
	public function getThemeId()
	{
		return $this->theme_id;
	}


	/**
	 * Set the value of `theme_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setThemeId($v)
	{
		if ($this->theme_id !== $v) {
			$this->theme_id = $v;
			$this->modifiedColumns[] = ThemePeer::THEME_ID;
		}
			
		  // update associated User		  
		  if ($this->collUsers !== null) {
			  for ($i=0,$size=count($this->collUsers); $i < $size; $i++) {
				  $this->collUsers[$i]->setThemeId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the Dirname column value.
	 *  
	 * @return string	  
	 */
	public function getDirname()
	{
		return $this->dirname;
	}


	/**
	 * Set the value of `dirname` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setDirname($v)
	{
		if ($this->dirname !== $v) {
			$this->dirname = $v;
			$this->modifiedColumns[] = ThemePeer::DIRNAME;
		}
				
	}

  
	/**
	 * Get the Fullname column value.
	 *  
	 * @return string	  
	 */
	public function getFullname()
	{
		return $this->fullname;
	}


	/**
	 * Set the value of `fullname` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFullname($v)
	{
		if ($this->fullname !== $v) {
			$this->fullname = $v;
			$this->modifiedColumns[] = ThemePeer::FULLNAME;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->theme_id = $rs->getInt($startcol + 0);					
			$this->dirname = $rs->getString($startcol + 1);					
			$this->fullname = $rs->getString($startcol + 2);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Theme object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(ThemePeer::DATABASE_NAME);
		$criteria->add(ThemePeer::THEME_ID, $this->theme_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(ThemePeer::DATABASE_NAME);
		if ($this->isColumnModified(ThemePeer::THEME_ID)) $criteria->add(ThemePeer::THEME_ID, $this->theme_id);
		if ($this->isColumnModified(ThemePeer::DIRNAME)) $criteria->add(ThemePeer::DIRNAME, $this->dirname);
		if ($this->isColumnModified(ThemePeer::FULLNAME)) $criteria->add(ThemePeer::FULLNAME, $this->fullname);
		return $criteria;			
	}
	
	

	/**
	 * Collection to store aggregation of collUsers	  
	 * @var array
	 */
	protected $collUsers; 

	/**
	 * Temporary storage of collUsers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUsers()
	{
		if ($this->collUsers === null) {
			$this->collUsers = array();
		}
	}

	/**
	 * Method called to associate a User object to this object
	 * through the User foreign key attribute
	 *
	 * @param User $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addUser(User $l)
	{
		$this->collUsers[] = $l;
		$l->setTheme($this);
	}

	/**
	 * The criteria used to select the current contents of collUsers.
	 * @var Criteria
	 */
	private $lastUsersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Theme has previously
	 * been saved, it will retrieve related Users from storage.
	 * If this Theme is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUsers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collUsers === null) {
			if ($this->isNew()) {
			   $this->collUsers = array();
			} else {
	
				$criteria->add(UserPeer::THEME_ID, $this->getThemeId() );

				$this->collUsers = UserPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UserPeer::THEME_ID, $this->getThemeId());

				if (!isset($this->lastUsersCriteria) || !$this->lastUsersCriteria->equals($criteria)) {
					$this->collUsers = UserPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUsersCriteria = $criteria;

		return $this->collUsers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Theme is new, it will return
	 * an empty collection; or if this Theme has previously
	 * been saved, it will retrieve related Users from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Theme.
	 */
	public function getUsersJoinCountryCode($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUsers === null) {
			if ($this->isNew()) {
			   $this->collUsers = array();
			} else {
	   
				$criteria->add(UserPeer::THEME_ID, $this->getThemeId());
				$this->collUsers = UserPeer::doSelectJoinCountryCode($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserPeer::THEME_ID, $this->getThemeId());
			if (!isset($this->lastUsersCriteria) || !$this->lastUsersCriteria->equals($criteria)) {
				$this->collUsers = UserPeer::doSelectJoinCountryCode($criteria, $con);
			}
		}
		$this->lastUsersCriteria = $criteria;

		return $this->collUsers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Theme is new, it will return
	 * an empty collection; or if this Theme has previously
	 * been saved, it will retrieve related Users from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Theme.
	 */
	public function getUsersJoinLanguage($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUsers === null) {
			if ($this->isNew()) {
			   $this->collUsers = array();
			} else {
	   
				$criteria->add(UserPeer::THEME_ID, $this->getThemeId());
				$this->collUsers = UserPeer::doSelectJoinLanguage($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserPeer::THEME_ID, $this->getThemeId());
			if (!isset($this->lastUsersCriteria) || !$this->lastUsersCriteria->equals($criteria)) {
				$this->collUsers = UserPeer::doSelectJoinLanguage($criteria, $con);
			}
		}
		$this->lastUsersCriteria = $criteria;

		return $this->collUsers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Theme is new, it will return
	 * an empty collection; or if this Theme has previously
	 * been saved, it will retrieve related Users from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Theme.
	 */
	public function getUsersJoinTheme($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUsers === null) {
			if ($this->isNew()) {
			   $this->collUsers = array();
			} else {
	   
				$criteria->add(UserPeer::THEME_ID, $this->getThemeId());
				$this->collUsers = UserPeer::doSelectJoinTheme($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserPeer::THEME_ID, $this->getThemeId());
			if (!isset($this->lastUsersCriteria) || !$this->lastUsersCriteria->equals($criteria)) {
				$this->collUsers = UserPeer::doSelectJoinTheme($criteria, $con);
			}
		}
		$this->lastUsersCriteria = $criteria;

		return $this->collUsers;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("theme_id", "dirname", "fullname", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case ThemePeer::THEME_ID:
				return $this->getThemeId();
				break;
		  
			case ThemePeer::DIRNAME:
				return $this->getDirname();
				break;
		  
			case ThemePeer::FULLNAME:
				return $this->getFullname();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getThemeId();
				break;
  
			case 1:
				return $this->getDirname();
				break;
  
			case 2:
				return $this->getFullname();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(ThemePeer::THEME_ID, $arr)) $this->setThemeId($arr[ThemePeer::THEME_ID]);
  
		if (array_key_exists(ThemePeer::DIRNAME, $arr)) $this->setDirname($arr[ThemePeer::DIRNAME]);
  
		if (array_key_exists(ThemePeer::FULLNAME, $arr)) $this->setFullname($arr[ThemePeer::FULLNAME]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case ThemePeer::THEME_ID:
				$this->setThemeId($value);
				break;
	  
			case ThemePeer::DIRNAME:
				$this->setDirname($value);
				break;
	  
			case ThemePeer::FULLNAME:
				$this->setFullname($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setThemeId($value);
				break;
  
			case 1:
				$this->setDirname($value);
				break;
  
			case 2:
				$this->setFullname($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(ThemePeer::DATABASE_NAME);

		try {
			$con->begin();
			ThemePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(ThemePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ThemePeer::doInsert($this, $con);
					$this->setThemeId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					ThemePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collUsers !== null) {
				for ($i=0,$size=count($this->collUsers); $i < $size; $i++) {
					$this->collUsers[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return ThemePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  

			if (($retval = ThemePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collUsers !== null) {
				for ($i=0,$size=count($this->collUsers); $i < $size; $i++) {
					if (($retval = $this->collUsers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed theme_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setThemeId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getThemeId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Theme Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Theme();
		$copyObj->setDirname($this->dirname);
		$copyObj->setFullname($this->fullname);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getUsers() as $relObj) {
				$copyObj->addUser($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setThemeId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return ThemePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ThemePeer();
		}
		return self::$peer;
	}

}
