<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/TroveCategory.php';
// (on-demand) include_once 'core/TroveCategoryPeer.php';

include_once 'core/TroveCategoryPeer.php';

/**
 * Base class that represents a row from the 'trove_category' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TroveCategory class. 
 * 
 * @package core 
 */
abstract class BaseTroveCategory extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TroveCategoryPeer
	 */
	protected static $peer;

	/**
	 * The value for the trove_category_id field.
	 * @var int	  
	 */
	protected $trove_category_id;	

	/**
	 * The value for the root_trove_category_id field.
	 * @var int	  
	 */
	protected $root_trove_category_id;	

	/**
	 * The value for the parent_trove_category_id field.
	 * @var int	  
	 */
	protected $parent_trove_category_id;	

	/**
	 * The value for the alias field.
	 * @var string	  
	 */
	protected $alias;	

	/**
	 * The value for the category_name field.
	 * @var string	  
	 */
	protected $category_name;	

	/**
	 * The value for the description field.
	 * @var string	  
	 */
	protected $description;	
  
	/**
	 * Get the TroveCategoryId column value.
	 *  
	 * @return int	  
	 */
	public function getTroveCategoryId()
	{
		return $this->trove_category_id;
	}


	/**
	 * Set the value of `trove_category_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTroveCategoryId($v)
	{
		if ($this->trove_category_id !== $v) {
			$this->trove_category_id = $v;
			$this->modifiedColumns[] = TroveCategoryPeer::TROVE_CATEGORY_ID;
		}
			  	
		  // update associated TroveLink		  
		  if ($this->collTroveLinks !== null) {
			  for ($i=0,$size=count($this->collTroveLinks); $i < $size; $i++) {
				  $this->collTroveLinks[$i]->setTroveCategoryId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the RootTroveCategoryId column value.
	 *  
	 * @return int	  
	 */
	public function getRootTroveCategoryId()
	{
		return $this->root_trove_category_id;
	}


	/**
	 * Set the value of `root_trove_category_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setRootTroveCategoryId($v)
	{
		if ($this->root_trove_category_id !== $v) {
			$this->root_trove_category_id = $v;
			$this->modifiedColumns[] = TroveCategoryPeer::ROOT_TROVE_CATEGORY_ID;
		}
				
	}

  
	/**
	 * Get the ParentTroveCategoryId column value.
	 *  
	 * @return int	  
	 */
	public function getParentTroveCategoryId()
	{
		return $this->parent_trove_category_id;
	}


	/**
	 * Set the value of `parent_trove_category_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setParentTroveCategoryId($v)
	{
		if ($this->parent_trove_category_id !== $v) {
			$this->parent_trove_category_id = $v;
			$this->modifiedColumns[] = TroveCategoryPeer::PARENT_TROVE_CATEGORY_ID;
		}
			
		if ($this->aTroveCategoryRelatedByParentTroveCategoryId !== null && $this->aTroveCategoryRelatedByParentTroveCategoryId->getTroveCategoryId() !== $v) {
			$this->aTroveCategoryRelatedByParentTroveCategoryId = null;
		}
			
	}

  
	/**
	 * Get the Alias column value.
	 *  
	 * @return string	  
	 */
	public function getAlias()
	{
		return $this->alias;
	}


	/**
	 * Set the value of `alias` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setAlias($v)
	{
		if ($this->alias !== $v) {
			$this->alias = $v;
			$this->modifiedColumns[] = TroveCategoryPeer::ALIAS;
		}
				
	}

  
	/**
	 * Get the CategoryName column value.
	 *  
	 * @return string	  
	 */
	public function getCategoryName()
	{
		return $this->category_name;
	}


	/**
	 * Set the value of `category_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setCategoryName($v)
	{
		if ($this->category_name !== $v) {
			$this->category_name = $v;
			$this->modifiedColumns[] = TroveCategoryPeer::CATEGORY_NAME;
		}
				
	}

  
	/**
	 * Get the Description column value.
	 *  
	 * @return string	  
	 */
	public function getDescription()
	{
		return $this->description;
	}


	/**
	 * Set the value of `description` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setDescription($v)
	{
		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = TroveCategoryPeer::DESCRIPTION;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->trove_category_id = $rs->getInt($startcol + 0);					
			$this->root_trove_category_id = $rs->getInt($startcol + 1);					
			$this->parent_trove_category_id = $rs->getInt($startcol + 2);					
			$this->alias = $rs->getString($startcol + 3);					
			$this->category_name = $rs->getString($startcol + 4);					
			$this->description = $rs->getString($startcol + 5);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating TroveCategory object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(TroveCategoryPeer::DATABASE_NAME);
		$criteria->add(TroveCategoryPeer::TROVE_CATEGORY_ID, $this->trove_category_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(TroveCategoryPeer::DATABASE_NAME);
		if ($this->isColumnModified(TroveCategoryPeer::TROVE_CATEGORY_ID)) $criteria->add(TroveCategoryPeer::TROVE_CATEGORY_ID, $this->trove_category_id);
		if ($this->isColumnModified(TroveCategoryPeer::ROOT_TROVE_CATEGORY_ID)) $criteria->add(TroveCategoryPeer::ROOT_TROVE_CATEGORY_ID, $this->root_trove_category_id);
		if ($this->isColumnModified(TroveCategoryPeer::PARENT_TROVE_CATEGORY_ID)) $criteria->add(TroveCategoryPeer::PARENT_TROVE_CATEGORY_ID, $this->parent_trove_category_id);
		if ($this->isColumnModified(TroveCategoryPeer::ALIAS)) $criteria->add(TroveCategoryPeer::ALIAS, $this->alias);
		if ($this->isColumnModified(TroveCategoryPeer::CATEGORY_NAME)) $criteria->add(TroveCategoryPeer::CATEGORY_NAME, $this->category_name);
		if ($this->isColumnModified(TroveCategoryPeer::DESCRIPTION)) $criteria->add(TroveCategoryPeer::DESCRIPTION, $this->description);
		return $criteria;			
	}
	
	

	/**
	 * @var TroveCategory	  
	 */
	protected $aTroveCategoryRelatedByParentTroveCategoryId;

	/**
	 * Declares an association between this object and a TroveCategory object
	 *
	 * @param TroveCategory $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTroveCategoryRelatedByParentTroveCategoryId($v)
	{
			
		if ($v === null) {
			$this->setParentTroveCategoryId(NULL);
		} else {
			$this->setParentTroveCategoryId($v->getTroveCategoryId());
		}
   
		$this->aTroveCategoryRelatedByParentTroveCategoryId = $v;
	}


	/**
	 * Get the associated TroveCategory object
	 *
	 * @param Connection Optional Connection object.
	 * @return TroveCategory The associated TroveCategory object.
	 * @throws PropelException
	 */
	public function getTroveCategoryRelatedByParentTroveCategoryId($con = null)
	{
		// include the Peer class
		include_once 'core/TroveCategoryPeer.php';

		if ($this->aTroveCategoryRelatedByParentTroveCategoryId === null && ($this->parent_trove_category_id !== null)) {
	
			$this->aTroveCategoryRelatedByParentTroveCategoryId = TroveCategoryPeer::retrieveByPK($this->parent_trove_category_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TroveCategoryPeer::retrieveByPK($this->parent_trove_category_id, $con);
			   $obj->addTroveCategorysRelatedByParentTroveCategoryId($this);
			 */
		}
		return $this->aTroveCategoryRelatedByParentTroveCategoryId;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTroveCategoryRelatedByParentTroveCategoryIdKey($key)
	{

		$this->setParentTroveCategoryId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collTroveCategorysRelatedByParentTroveCategoryId	  
	 * @var array
	 */
	protected $collTroveCategorysRelatedByParentTroveCategoryId; 

	/**
	 * Temporary storage of collTroveCategorysRelatedByParentTroveCategoryId to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTroveCategorysRelatedByParentTroveCategoryId()
	{
		if ($this->collTroveCategorysRelatedByParentTroveCategoryId === null) {
			$this->collTroveCategorysRelatedByParentTroveCategoryId = array();
		}
	}

	/**
	 * Method called to associate a TroveCategory object to this object
	 * through the TroveCategory foreign key attribute
	 *
	 * @param TroveCategory $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTroveCategoryRelatedByParentTroveCategoryId(TroveCategory $l)
	{
		$this->collTroveCategorysRelatedByParentTroveCategoryId[] = $l;
		$l->setTroveCategoryRelatedByParentTroveCategoryId($this);
	}

	/**
	 * The criteria used to select the current contents of collTroveCategorysRelatedByParentTroveCategoryId.
	 * @var Criteria
	 */
	private $lastTroveCategorysRelatedByParentTroveCategoryIdCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TroveCategory has previously
	 * been saved, it will retrieve related TroveCategorysRelatedByParentTroveCategoryId from storage.
	 * If this TroveCategory is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTroveCategorysRelatedByParentTroveCategoryId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/TroveCategoryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTroveCategorysRelatedByParentTroveCategoryId === null) {
			if ($this->isNew()) {
			   $this->collTroveCategorysRelatedByParentTroveCategoryId = array();
			} else {
	
				$criteria->add(TroveCategoryPeer::PARENT_TROVE_CATEGORY_ID, $this->getTroveCategoryId() );

				$this->collTroveCategorysRelatedByParentTroveCategoryId = TroveCategoryPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TroveCategoryPeer::PARENT_TROVE_CATEGORY_ID, $this->getTroveCategoryId());

				if (!isset($this->lastTroveCategorysRelatedByParentTroveCategoryIdCriteria) || !$this->lastTroveCategorysRelatedByParentTroveCategoryIdCriteria->equals($criteria)) {
					$this->collTroveCategorysRelatedByParentTroveCategoryId = TroveCategoryPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTroveCategorysRelatedByParentTroveCategoryIdCriteria = $criteria;

		return $this->collTroveCategorysRelatedByParentTroveCategoryId;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TroveCategory is new, it will return
	 * an empty collection; or if this TroveCategory has previously
	 * been saved, it will retrieve related TroveCategorysRelatedByParentTroveCategoryId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TroveCategory.
	 */
	public function getTroveCategorysRelatedByParentTroveCategoryIdJoinTroveCategory($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/TroveCategoryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTroveCategorysRelatedByParentTroveCategoryId === null) {
			if ($this->isNew()) {
			   $this->collTroveCategorysRelatedByParentTroveCategoryId = array();
			} else {
	   
				$criteria->add(TroveCategoryPeer::PARENT_TROVE_CATEGORY_ID, $this->getTroveCategoryId());
				$this->collTroveCategorysRelatedByParentTroveCategoryId = TroveCategoryPeer::doSelectJoinTroveCategory($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TroveCategoryPeer::PARENT_TROVE_CATEGORY_ID, $this->getTroveCategoryId());
			if (!isset($this->lastTroveCategorysRelatedByParentTroveCategoryIdCriteria) || !$this->lastTroveCategorysRelatedByParentTroveCategoryIdCriteria->equals($criteria)) {
				$this->collTroveCategorysRelatedByParentTroveCategoryId = TroveCategoryPeer::doSelectJoinTroveCategory($criteria, $con);
			}
		}
		$this->lastTroveCategorysRelatedByParentTroveCategoryIdCriteria = $criteria;

		return $this->collTroveCategorysRelatedByParentTroveCategoryId;
	}

	/**
	 * Collection to store aggregation of collTroveLinks	  
	 * @var array
	 */
	protected $collTroveLinks; 

	/**
	 * Temporary storage of collTroveLinks to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTroveLinks()
	{
		if ($this->collTroveLinks === null) {
			$this->collTroveLinks = array();
		}
	}

	/**
	 * Method called to associate a TroveLink object to this object
	 * through the TroveLink foreign key attribute
	 *
	 * @param TroveLink $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTroveLink(TroveLink $l)
	{
		$this->collTroveLinks[] = $l;
		$l->setTroveCategory($this);
	}

	/**
	 * The criteria used to select the current contents of collTroveLinks.
	 * @var Criteria
	 */
	private $lastTroveLinksCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TroveCategory has previously
	 * been saved, it will retrieve related TroveLinks from storage.
	 * If this TroveCategory is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTroveLinks($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/TroveLinkPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTroveLinks === null) {
			if ($this->isNew()) {
			   $this->collTroveLinks = array();
			} else {
	
				$criteria->add(TroveLinkPeer::TROVE_CATEGORY_ID, $this->getTroveCategoryId() );

				$this->collTroveLinks = TroveLinkPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TroveLinkPeer::TROVE_CATEGORY_ID, $this->getTroveCategoryId());

				if (!isset($this->lastTroveLinksCriteria) || !$this->lastTroveLinksCriteria->equals($criteria)) {
					$this->collTroveLinks = TroveLinkPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTroveLinksCriteria = $criteria;

		return $this->collTroveLinks;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TroveCategory is new, it will return
	 * an empty collection; or if this TroveCategory has previously
	 * been saved, it will retrieve related TroveLinks from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TroveCategory.
	 */
	public function getTroveLinksJoinTroveCategory($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/TroveLinkPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTroveLinks === null) {
			if ($this->isNew()) {
			   $this->collTroveLinks = array();
			} else {
	   
				$criteria->add(TroveLinkPeer::TROVE_CATEGORY_ID, $this->getTroveCategoryId());
				$this->collTroveLinks = TroveLinkPeer::doSelectJoinTroveCategory($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TroveLinkPeer::TROVE_CATEGORY_ID, $this->getTroveCategoryId());
			if (!isset($this->lastTroveLinksCriteria) || !$this->lastTroveLinksCriteria->equals($criteria)) {
				$this->collTroveLinks = TroveLinkPeer::doSelectJoinTroveCategory($criteria, $con);
			}
		}
		$this->lastTroveLinksCriteria = $criteria;

		return $this->collTroveLinks;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("trove_category_id", "root_trove_category_id", "parent_trove_category_id", "alias", "category_name", "description", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case TroveCategoryPeer::TROVE_CATEGORY_ID:
				return $this->getTroveCategoryId();
				break;
		  
			case TroveCategoryPeer::ROOT_TROVE_CATEGORY_ID:
				return $this->getRootTroveCategoryId();
				break;
		  
			case TroveCategoryPeer::PARENT_TROVE_CATEGORY_ID:
				return $this->getParentTroveCategoryId();
				break;
		  
			case TroveCategoryPeer::ALIAS:
				return $this->getAlias();
				break;
		  
			case TroveCategoryPeer::CATEGORY_NAME:
				return $this->getCategoryName();
				break;
		  
			case TroveCategoryPeer::DESCRIPTION:
				return $this->getDescription();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getTroveCategoryId();
				break;
  
			case 1:
				return $this->getRootTroveCategoryId();
				break;
  
			case 2:
				return $this->getParentTroveCategoryId();
				break;
  
			case 3:
				return $this->getAlias();
				break;
  
			case 4:
				return $this->getCategoryName();
				break;
  
			case 5:
				return $this->getDescription();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(TroveCategoryPeer::TROVE_CATEGORY_ID, $arr)) $this->setTroveCategoryId($arr[TroveCategoryPeer::TROVE_CATEGORY_ID]);
  
		if (array_key_exists(TroveCategoryPeer::ROOT_TROVE_CATEGORY_ID, $arr)) $this->setRootTroveCategoryId($arr[TroveCategoryPeer::ROOT_TROVE_CATEGORY_ID]);
  
		if (array_key_exists(TroveCategoryPeer::PARENT_TROVE_CATEGORY_ID, $arr)) $this->setParentTroveCategoryId($arr[TroveCategoryPeer::PARENT_TROVE_CATEGORY_ID]);
  
		if (array_key_exists(TroveCategoryPeer::ALIAS, $arr)) $this->setAlias($arr[TroveCategoryPeer::ALIAS]);
  
		if (array_key_exists(TroveCategoryPeer::CATEGORY_NAME, $arr)) $this->setCategoryName($arr[TroveCategoryPeer::CATEGORY_NAME]);
  
		if (array_key_exists(TroveCategoryPeer::DESCRIPTION, $arr)) $this->setDescription($arr[TroveCategoryPeer::DESCRIPTION]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case TroveCategoryPeer::TROVE_CATEGORY_ID:
				$this->setTroveCategoryId($value);
				break;
	  
			case TroveCategoryPeer::ROOT_TROVE_CATEGORY_ID:
				$this->setRootTroveCategoryId($value);
				break;
	  
			case TroveCategoryPeer::PARENT_TROVE_CATEGORY_ID:
				$this->setParentTroveCategoryId($value);
				break;
	  
			case TroveCategoryPeer::ALIAS:
				$this->setAlias($value);
				break;
	  
			case TroveCategoryPeer::CATEGORY_NAME:
				$this->setCategoryName($value);
				break;
	  
			case TroveCategoryPeer::DESCRIPTION:
				$this->setDescription($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setTroveCategoryId($value);
				break;
  
			case 1:
				$this->setRootTroveCategoryId($value);
				break;
  
			case 2:
				$this->setParentTroveCategoryId($value);
				break;
  
			case 3:
				$this->setAlias($value);
				break;
  
			case 4:
				$this->setCategoryName($value);
				break;
  
			case 5:
				$this->setDescription($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(TroveCategoryPeer::DATABASE_NAME);

		try {
			$con->begin();
			TroveCategoryPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(TroveCategoryPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aTroveCategoryRelatedByParentTroveCategoryId !== null) {
				if ($this->aTroveCategoryRelatedByParentTroveCategoryId->isModified()) $this->aTroveCategoryRelatedByParentTroveCategoryId->save($con);
				$this->setTroveCategoryRelatedByParentTroveCategoryId($this->aTroveCategoryRelatedByParentTroveCategoryId);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TroveCategoryPeer::doInsert($this, $con);
					$this->setTroveCategoryId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					TroveCategoryPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collTroveLinks !== null) {
				for ($i=0,$size=count($this->collTroveLinks); $i < $size; $i++) {
					$this->collTroveLinks[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return TroveCategoryPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aTroveCategoryRelatedByParentTroveCategoryId !== null) {
				if (($retval = $this->aTroveCategoryRelatedByParentTroveCategoryId->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = TroveCategoryPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collTroveLinks !== null) {
				for ($i=0,$size=count($this->collTroveLinks); $i < $size; $i++) {
					if (($retval = $this->collTroveLinks[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed trove_category_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setTroveCategoryId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getTroveCategoryId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return TroveCategory Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new TroveCategory();
		$copyObj->setRootTroveCategoryId($this->root_trove_category_id);
		$copyObj->setParentTroveCategoryId($this->parent_trove_category_id);
		$copyObj->setAlias($this->alias);
		$copyObj->setCategoryName($this->category_name);
		$copyObj->setDescription($this->description);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getTroveLinks() as $relObj) {
				$copyObj->addTroveLink($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setTroveCategoryId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return TroveCategoryPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TroveCategoryPeer();
		}
		return self::$peer;
	}

}
