<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/SiteTemplate.php');
require_once('exceptions/NotLoggedInException.php');

class UserTemplate extends SiteTemplate {

	function header($params) {		
		if (!isset($params['title'])) {
			Throw new exception('Missing title in my template');
		}
		if (!isset($params['user']) || !is_object($params['user'])) {
			Throw new exception('Missing user object in my template');
		}
		$Lang = Session::getSession()->getLanguage();
		$params['title']=$Lang->getText('Tabs.Users').' > '.$params['title'];
		$params['selectedtoptab']='user';
		$this->addBreadCrumb($params['user']->getUserLink());
		$this->addBreadCrumb('<a href="/gf/user/">'.$Lang->getText('Tabs.Users').'</a>');
		return parent::header($params);
	}

	/**
	 *      getPluginNavElements - this overrides parent class and adds its own
	 *      plugin listener
	 *      @return PluginResultSet
	 */
	function getPluginNavElements($params) {
		$prs = parent::getPluginNavElements($params);
		$tprs = ActionManager::Notify('GET_USER_NAV_ELEMENTS',$params);
		foreach ($tprs as $pr) {
			$prs->addResult($pr);
		}
		return $prs;
	}

	/**
	 * getTemplateNavElements - this function can be overridden
	 * by subclasses so you can add navigation entries
	 * @return array - complex array of data.
	 * /
	function getTemplateNavElements($params) {
		$pine = $this->getPluginNavElements($params);
		$ret = array();
		foreach ($pine as $result) {
			$ret[]=$result->getResult();
		}
		$ret[] = array(
			'title'=>'My Stuff',
			'elements'=> array(
			array('link'=>'/gf/my/?action=TrackerItemBrowse',
				'description'=>'My Account'),
			array('link'=>'/gf/my/?action=UserPasswordEdit',
				'description'=>'Change Password'),
			array('link'=>'/gf/my/?action=UserEmailEdit',
				'description'=>'Change Email'),
			array('link'=>'/gf/my/?action=UserPluginsEdit',
				'description'=>'Plugins'),
			array('link'=>'/gf/my/?action=UserSSHKeysEdit',
				'description'=>'Edit SSH Keys')
				)
			);
		return $ret;
	}
	*/
	/**
	 *	secondTabs() - Prints out the project tabs, contained here in case
	 *		we want to allow it to be overriden
	 *
	 *	@param	array	project, selected tab
	 */
	function secondTabs($params) {
/*
//		echo $this->renderTabs($TABS_DIRS,$TABS_TITLES,true,$selected,'white','100%');
		if(array_key_exists('project', $params)){
			if (array_key_exists('selectedbottomtab', $params)) {
				$selectedTab = $params['selectedbottomtab'];
			} else {
				$selectedTab = false;
			}
			
			$project = GFUrl::getUrl()->getProject();
			
			$tabs = array();
			// "Summary" tab
			$tabs[] = array(
					'text'	=>	Language::getSessText('Tabs.Summary'),
					'id'	=>	'summary',
					'action'	=> 	GFUrl::getUrl()->projectURL($project)
				);
			// "Admin" tab
			$tabs[] = array(
					'text'	=>	Language::getSessText('Tabs.ProjectAdmin'),
					'id'	=>	'project_admin',
					'action'	=> 	GFUrl::getUrl()->projectURL($project, '', 'admin')
				);
			// "Admin" tab
			$tabs[] = array(
					'text'	=>	Language::getSessText('Tabs.ProjectReporting'),
					'id'	=>	'reporting',
					'action'	=> 	GFUrl::getUrl()->projectURL($project, '', 'reporting')
				);
			
			$prs = ActionManager::notify("BUILD_MYPAGE_ELEMENTS",$params);
			foreach ($prs as $result) {
				$tabs[] = $result->getResult();
			}
			
			echo $this->renderTabs($tabs, $selectedTab, true);
		}
*/
		if(array_key_exists('user', $params)){
			if (array_key_exists('selectedbottomtab', $params)) {
				$selectedTab = $params['selectedbottomtab'];
			} else {
				$selectedTab = false;
			}
			
			$tabs = array();
			// "User" tab
			$tabs[] = array(
					'text'	=>	Language::getSessText('Tabs.Summary'),
					'id'	=>	'UserBrowse',
					'action'	=> 	GFUrl::getUrl()->baseURL('', '', 'user/'.$params['user']->getUnixName())
				);
			// "User Projects" tab
			$tabs[] = array(
					'text'	 =>	Language::getSessText('Tabs.Projects'),
					'id'	 =>	'project',
					'action' => 	GFUrl::getUrl()->baseURL('Projects', '', 'user/'.$params['user']->getUnixName())
				);
			
			$prs = ActionManager::notify("BUILD_USER_TABS",$params);
			foreach ($prs as $result) {
				$tabs[] = $result->getResult();
			}
			
			echo $this->renderTabs($tabs, $selectedTab, true, $params);
		}
	}

}

?>
