<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a DocmanFolder and saves it to the 
// database
//
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$project = GFUrl::getUrl()->getProject();
$folder_id = $_POST['id'];
$DocmanFolder = DocmanFolderPeer::retrieveByPk($folder_id);
if (!is_object($DocmanFolder) || !$DocmanFolder->userCanUpdate()) {
	throw new PermissionDeniedException();
}
if ($DocmanFolder->getProject()->getProjectId() != $project->getProjectId()) {
	throw new PermissionDeniedException();
}

$Lang = Language::getSessLang();

$is_public = ((isset($_POST) && isset($_POST['is_public'])) ? $_POST['is_public'] : 0);

try {
	$DocmanFolder->setFolderName( Validator::sanitizeString($_POST['folder_name']) );
	$DocmanFolder->setIsPublic( Validator::sanitizeBool($is_public) );
	//The folder_parent_id select in form does not exclude the current folder, so a check is needed
	if($_POST['folder_parent_id'] != $DocmanFolder->getId()){
		$DocmanFolder->setParentFolderId(Validator::sanitizeInt($_POST['folder_parent_id']));
	}
	
	$DocmanFolder->save();
	$url = GFUrl::getUrl();
	GFUrl::redirect($url->currentBaseURL('DocmanFolderBrowse'), array('feedback' => $Lang->getText('DocmanFolder.EditFeedback')));
} catch (InvalidDataException $ex) {
	$errors=$ex->getErrors();
	$feedback = implode('<br />', $errors);
	include('DocmanFolderEdit.php');
}

?>
