<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'forum_thread' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.forum.lib.map
 */
class ForumThreadMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.forum.lib.map.ForumThreadMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("forum_thread");
		$tMap->setPhpName("ForumThread");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("forum_thread_forum_thread_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("FORUM_THREAD_ID", "ForumThreadId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("FORUM_ID", "ForumId", "int", CreoleTypes::INTEGER, "forum" , "FORUM_ID", true);
		$tMap->addForeignKey("CREATED_BY", "CreatedBy", "int", CreoleTypes::INTEGER, "user" , "USER_ID", true);
		$tMap->addColumn("THREAD_NAME", "ThreadName", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("MESSAGE_COUNT", "MessageCount", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("MOST_RECENT_DATE", "MostRecentDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("IS_STICKY", "IsSticky", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("IS_LOCKED", "IsLocked", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("PAGE_VIEWS", "PageViews", "int", CreoleTypes::INTEGER, false, null);
				
    }
}
