<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/forum/lib/Forum.php';
// (on-demand) include_once 'plugins/forum/lib/ForumPeer.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'plugins/forum/lib/ForumThreadPeer.php';

/**
 * Base class that represents a row from the 'forum_thread' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to ForumThread class. 
 * 
 * @package plugins.forum.lib 
 */
abstract class BaseForumThread extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var ForumThreadPeer
	 */
	protected static $peer;

	/**
	 * The value for the forum_thread_id field.
	 * @var int	  
	 */
	protected $forum_thread_id;	

	/**
	 * The value for the forum_id field.
	 * @var int	  
	 */
	protected $forum_id;	

	/**
	 * The value for the created_by field.
	 * @var int	  
	 */
	protected $created_by;	

	/**
	 * The value for the thread_name field.
	 * @var string	  
	 */
	protected $thread_name;	

	/**
	 * The value for the message_count field.
	 * @var int	  
	 */
	protected $message_count = 0;	

	/**
	 * The value for the most_recent_date field.
	 * @var int	  
	 */
	protected $most_recent_date = -1;	

	/**
	 * The value for the is_sticky field.
	 * @var boolean	  
	 */
	protected $is_sticky = false;	

	/**
	 * The value for the is_locked field.
	 * @var boolean	  
	 */
	protected $is_locked = false;	

	/**
	 * The value for the page_views field.
	 * @var int	  
	 */
	protected $page_views = 0;	
  
	/**
	 * Get the ForumThreadId column value.
	 *  
	 * @return int	  
	 */
	public function getForumThreadId()
	{
		return $this->forum_thread_id;
	}


	/**
	 * Set the value of `forum_thread_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setForumThreadId($v)
	{
		if ($this->forum_thread_id !== $v) {
			$this->forum_thread_id = $v;
			$this->modifiedColumns[] = ForumThreadPeer::FORUM_THREAD_ID;
		}
			
		  // update associated ForumMessage		  
		  if ($this->collForumMessages !== null) {
			  for ($i=0,$size=count($this->collForumMessages); $i < $size; $i++) {
				  $this->collForumMessages[$i]->setForumThreadId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the ForumId column value.
	 *  
	 * @return int	  
	 */
	public function getForumId()
	{
		return $this->forum_id;
	}


	/**
	 * Set the value of `forum_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setForumId($v)
	{
		if ($this->forum_id !== $v) {
			$this->forum_id = $v;
			$this->modifiedColumns[] = ForumThreadPeer::FORUM_ID;
		}
			
		if ($this->aForum !== null && $this->aForum->getForumId() !== $v) {
			$this->aForum = null;
		}
			
	}

  
	/**
	 * Get the CreatedBy column value.
	 *  
	 * @return int	  
	 */
	public function getCreatedBy()
	{
		return $this->created_by;
	}


	/**
	 * Set the value of `created_by` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCreatedBy($v)
	{
		if ($this->created_by !== $v) {
			$this->created_by = $v;
			$this->modifiedColumns[] = ForumThreadPeer::CREATED_BY;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}

  
	/**
	 * Get the ThreadName column value.
	 *  
	 * @return string	  
	 */
	public function getThreadName()
	{
		return $this->thread_name;
	}


	/**
	 * Set the value of `thread_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setThreadName($v)
	{
		if ($this->thread_name !== $v) {
			$this->thread_name = $v;
			$this->modifiedColumns[] = ForumThreadPeer::THREAD_NAME;
		}
				
	}

  
	/**
	 * Get the MessageCount column value.
	 *  
	 * @return int	  
	 */
	public function getMessageCount()
	{
		return $this->message_count;
	}


	/**
	 * Set the value of `message_count` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setMessageCount($v)
	{
		if ($this->message_count !== $v || $v === 0) {
			$this->message_count = $v;
			$this->modifiedColumns[] = ForumThreadPeer::MESSAGE_COUNT;
		}
				
	}


	/**
	 * Get the [optionally formatted] `most_recent_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getMostRecentDate($format = 'Y-m-d H:i:s')
	{
		if ($this->most_recent_date === null || $this->most_recent_date === '') {
			return null;
		} elseif (!is_int($this->most_recent_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->most_recent_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of most_recent_date as date/time value: " . var_export($this->most_recent_date, true));
			}
		} else {
			$ts = $this->most_recent_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `most_recent_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setMostRecentDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for most_recent_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->most_recent_date !== $ts || $ts === -1) {
			$this->most_recent_date = $ts;
			$this->modifiedColumns[] = ForumThreadPeer::MOST_RECENT_DATE;
		}
		
	}

  
	/**
	 * Get the IsSticky column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsSticky()
	{
		return $this->is_sticky;
	}


	/**
	 * Set the value of `is_sticky` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsSticky($v)
	{
		if ($this->is_sticky !== $v || $v === false) {
			$this->is_sticky = $v;
			$this->modifiedColumns[] = ForumThreadPeer::IS_STICKY;
		}
				
	}

  
	/**
	 * Get the IsLocked column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsLocked()
	{
		return $this->is_locked;
	}


	/**
	 * Set the value of `is_locked` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsLocked($v)
	{
		if ($this->is_locked !== $v || $v === false) {
			$this->is_locked = $v;
			$this->modifiedColumns[] = ForumThreadPeer::IS_LOCKED;
		}
				
	}

  
	/**
	 * Get the PageViews column value.
	 *  
	 * @return int	  
	 */
	public function getPageViews()
	{
		return $this->page_views;
	}


	/**
	 * Set the value of `page_views` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setPageViews($v)
	{
		if ($this->page_views !== $v || $v === 0) {
			$this->page_views = $v;
			$this->modifiedColumns[] = ForumThreadPeer::PAGE_VIEWS;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->forum_thread_id = $rs->getInt($startcol + 0);					
			$this->forum_id = $rs->getInt($startcol + 1);					
			$this->created_by = $rs->getInt($startcol + 2);					
			$this->thread_name = $rs->getString($startcol + 3);					
			$this->message_count = $rs->getInt($startcol + 4);					
			$this->most_recent_date = $rs->getTimestamp($startcol + 5, null);
			$this->is_sticky = $rs->getBoolean($startcol + 6);					
			$this->is_locked = $rs->getBoolean($startcol + 7);					
			$this->page_views = $rs->getInt($startcol + 8);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating ForumThread object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(ForumThreadPeer::DATABASE_NAME);
		$criteria->add(ForumThreadPeer::FORUM_THREAD_ID, $this->forum_thread_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(ForumThreadPeer::DATABASE_NAME);
		if ($this->isColumnModified(ForumThreadPeer::FORUM_THREAD_ID)) $criteria->add(ForumThreadPeer::FORUM_THREAD_ID, $this->forum_thread_id);
		if ($this->isColumnModified(ForumThreadPeer::FORUM_ID)) $criteria->add(ForumThreadPeer::FORUM_ID, $this->forum_id);
		if ($this->isColumnModified(ForumThreadPeer::CREATED_BY)) $criteria->add(ForumThreadPeer::CREATED_BY, $this->created_by);
		if ($this->isColumnModified(ForumThreadPeer::THREAD_NAME)) $criteria->add(ForumThreadPeer::THREAD_NAME, $this->thread_name);
		if ($this->isColumnModified(ForumThreadPeer::MESSAGE_COUNT)) $criteria->add(ForumThreadPeer::MESSAGE_COUNT, $this->message_count);
		if ($this->isColumnModified(ForumThreadPeer::MOST_RECENT_DATE)) $criteria->add(ForumThreadPeer::MOST_RECENT_DATE, $this->most_recent_date);
		if ($this->isColumnModified(ForumThreadPeer::IS_STICKY)) $criteria->add(ForumThreadPeer::IS_STICKY, $this->is_sticky);
		if ($this->isColumnModified(ForumThreadPeer::IS_LOCKED)) $criteria->add(ForumThreadPeer::IS_LOCKED, $this->is_locked);
		if ($this->isColumnModified(ForumThreadPeer::PAGE_VIEWS)) $criteria->add(ForumThreadPeer::PAGE_VIEWS, $this->page_views);
		return $criteria;			
	}
	
	

	/**
	 * @var Forum	  
	 */
	protected $aForum;

	/**
	 * Declares an association between this object and a Forum object
	 *
	 * @param Forum $v
	 * @return void
	 * @throws PropelException
	 */
	public function setForum($v)
	{
			
		if ($v === null) {
			$this->setForumId(NULL);
		} else {
			$this->setForumId($v->getForumId());
		}
   
		$this->aForum = $v;
	}


	/**
	 * Get the associated Forum object
	 *
	 * @param Connection Optional Connection object.
	 * @return Forum The associated Forum object.
	 * @throws PropelException
	 */
	public function getForum($con = null)
	{
		// include the Peer class
		include_once 'plugins/forum/lib/ForumPeer.php';

		if ($this->aForum === null && ($this->forum_id !== null)) {
	
			$this->aForum = ForumPeer::retrieveByPK($this->forum_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ForumPeer::retrieveByPK($this->forum_id, $con);
			   $obj->addForumThreads($this);
			 */
		}
		return $this->aForum;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setForumKey($key)
	{

		$this->setForumId( (int) $key);			
		
	}

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setCreatedBy(NULL);
		} else {
			$this->setCreatedBy($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->created_by !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->created_by, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->created_by, $con);
			   $obj->addForumThreads($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setCreatedBy( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collForumMessages	  
	 * @var array
	 */
	protected $collForumMessages; 

	/**
	 * Temporary storage of collForumMessages to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initForumMessages()
	{
		if ($this->collForumMessages === null) {
			$this->collForumMessages = array();
		}
	}

	/**
	 * Method called to associate a ForumMessage object to this object
	 * through the ForumMessage foreign key attribute
	 *
	 * @param ForumMessage $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addForumMessage(ForumMessage $l)
	{
		$this->collForumMessages[] = $l;
		$l->setForumThread($this);
	}

	/**
	 * The criteria used to select the current contents of collForumMessages.
	 * @var Criteria
	 */
	private $lastForumMessagesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this ForumThread has previously
	 * been saved, it will retrieve related ForumMessages from storage.
	 * If this ForumThread is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getForumMessages($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/forum/lib/ForumMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collForumMessages === null) {
			if ($this->isNew()) {
			   $this->collForumMessages = array();
			} else {
	
				$criteria->add(ForumMessagePeer::FORUM_THREAD_ID, $this->getForumThreadId() );

				$this->collForumMessages = ForumMessagePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ForumMessagePeer::FORUM_THREAD_ID, $this->getForumThreadId());

				if (!isset($this->lastForumMessagesCriteria) || !$this->lastForumMessagesCriteria->equals($criteria)) {
					$this->collForumMessages = ForumMessagePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastForumMessagesCriteria = $criteria;

		return $this->collForumMessages;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this ForumThread is new, it will return
	 * an empty collection; or if this ForumThread has previously
	 * been saved, it will retrieve related ForumMessages from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in ForumThread.
	 */
	public function getForumMessagesJoinForumThread($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/forum/lib/ForumMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collForumMessages === null) {
			if ($this->isNew()) {
			   $this->collForumMessages = array();
			} else {
	   
				$criteria->add(ForumMessagePeer::FORUM_THREAD_ID, $this->getForumThreadId());
				$this->collForumMessages = ForumMessagePeer::doSelectJoinForumThread($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ForumMessagePeer::FORUM_THREAD_ID, $this->getForumThreadId());
			if (!isset($this->lastForumMessagesCriteria) || !$this->lastForumMessagesCriteria->equals($criteria)) {
				$this->collForumMessages = ForumMessagePeer::doSelectJoinForumThread($criteria, $con);
			}
		}
		$this->lastForumMessagesCriteria = $criteria;

		return $this->collForumMessages;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this ForumThread is new, it will return
	 * an empty collection; or if this ForumThread has previously
	 * been saved, it will retrieve related ForumMessages from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in ForumThread.
	 */
	public function getForumMessagesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/forum/lib/ForumMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collForumMessages === null) {
			if ($this->isNew()) {
			   $this->collForumMessages = array();
			} else {
	   
				$criteria->add(ForumMessagePeer::FORUM_THREAD_ID, $this->getForumThreadId());
				$this->collForumMessages = ForumMessagePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ForumMessagePeer::FORUM_THREAD_ID, $this->getForumThreadId());
			if (!isset($this->lastForumMessagesCriteria) || !$this->lastForumMessagesCriteria->equals($criteria)) {
				$this->collForumMessages = ForumMessagePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastForumMessagesCriteria = $criteria;

		return $this->collForumMessages;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("forum_thread_id", "forum_id", "created_by", "thread_name", "message_count", "most_recent_date", "is_sticky", "is_locked", "page_views", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case ForumThreadPeer::FORUM_THREAD_ID:
				return $this->getForumThreadId();
				break;
		  
			case ForumThreadPeer::FORUM_ID:
				return $this->getForumId();
				break;
		  
			case ForumThreadPeer::CREATED_BY:
				return $this->getCreatedBy();
				break;
		  
			case ForumThreadPeer::THREAD_NAME:
				return $this->getThreadName();
				break;
		  
			case ForumThreadPeer::MESSAGE_COUNT:
				return $this->getMessageCount();
				break;
		  
			case ForumThreadPeer::MOST_RECENT_DATE:
				return $this->getMostRecentDate();
				break;
		  
			case ForumThreadPeer::IS_STICKY:
				return $this->getIsSticky();
				break;
		  
			case ForumThreadPeer::IS_LOCKED:
				return $this->getIsLocked();
				break;
		  
			case ForumThreadPeer::PAGE_VIEWS:
				return $this->getPageViews();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getForumThreadId();
				break;
  
			case 1:
				return $this->getForumId();
				break;
  
			case 2:
				return $this->getCreatedBy();
				break;
  
			case 3:
				return $this->getThreadName();
				break;
  
			case 4:
				return $this->getMessageCount();
				break;
  
			case 5:
				return $this->getMostRecentDate();
				break;
  
			case 6:
				return $this->getIsSticky();
				break;
  
			case 7:
				return $this->getIsLocked();
				break;
  
			case 8:
				return $this->getPageViews();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(ForumThreadPeer::FORUM_THREAD_ID, $arr)) $this->setForumThreadId($arr[ForumThreadPeer::FORUM_THREAD_ID]);
  
		if (array_key_exists(ForumThreadPeer::FORUM_ID, $arr)) $this->setForumId($arr[ForumThreadPeer::FORUM_ID]);
  
		if (array_key_exists(ForumThreadPeer::CREATED_BY, $arr)) $this->setCreatedBy($arr[ForumThreadPeer::CREATED_BY]);
  
		if (array_key_exists(ForumThreadPeer::THREAD_NAME, $arr)) $this->setThreadName($arr[ForumThreadPeer::THREAD_NAME]);
  
		if (array_key_exists(ForumThreadPeer::MESSAGE_COUNT, $arr)) $this->setMessageCount($arr[ForumThreadPeer::MESSAGE_COUNT]);
  
		if (array_key_exists(ForumThreadPeer::MOST_RECENT_DATE, $arr)) $this->setMostRecentDate($arr[ForumThreadPeer::MOST_RECENT_DATE]);
  
		if (array_key_exists(ForumThreadPeer::IS_STICKY, $arr)) $this->setIsSticky($arr[ForumThreadPeer::IS_STICKY]);
  
		if (array_key_exists(ForumThreadPeer::IS_LOCKED, $arr)) $this->setIsLocked($arr[ForumThreadPeer::IS_LOCKED]);
  
		if (array_key_exists(ForumThreadPeer::PAGE_VIEWS, $arr)) $this->setPageViews($arr[ForumThreadPeer::PAGE_VIEWS]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case ForumThreadPeer::FORUM_THREAD_ID:
				$this->setForumThreadId($value);
				break;
	  
			case ForumThreadPeer::FORUM_ID:
				$this->setForumId($value);
				break;
	  
			case ForumThreadPeer::CREATED_BY:
				$this->setCreatedBy($value);
				break;
	  
			case ForumThreadPeer::THREAD_NAME:
				$this->setThreadName($value);
				break;
	  
			case ForumThreadPeer::MESSAGE_COUNT:
				$this->setMessageCount($value);
				break;
	  
			case ForumThreadPeer::MOST_RECENT_DATE:
				$this->setMostRecentDate($value);
				break;
	  
			case ForumThreadPeer::IS_STICKY:
				$this->setIsSticky($value);
				break;
	  
			case ForumThreadPeer::IS_LOCKED:
				$this->setIsLocked($value);
				break;
	  
			case ForumThreadPeer::PAGE_VIEWS:
				$this->setPageViews($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setForumThreadId($value);
				break;
  
			case 1:
				$this->setForumId($value);
				break;
  
			case 2:
				$this->setCreatedBy($value);
				break;
  
			case 3:
				$this->setThreadName($value);
				break;
  
			case 4:
				$this->setMessageCount($value);
				break;
  
			case 5:
				$this->setMostRecentDate($value);
				break;
  
			case 6:
				$this->setIsSticky($value);
				break;
  
			case 7:
				$this->setIsLocked($value);
				break;
  
			case 8:
				$this->setPageViews($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(ForumThreadPeer::DATABASE_NAME);

		try {
			$con->begin();
			ForumThreadPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(ForumThreadPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aForum !== null) {
				if ($this->aForum->isModified()) $this->aForum->save($con);
				$this->setForum($this->aForum);
			}
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ForumThreadPeer::doInsert($this, $con);
					$this->setForumThreadId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					ForumThreadPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collForumMessages !== null) {
				for ($i=0,$size=count($this->collForumMessages); $i < $size; $i++) {
					$this->collForumMessages[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return ForumThreadPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aForum !== null) {
				if (($retval = $this->aForum->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = ForumThreadPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collForumMessages !== null) {
				for ($i=0,$size=count($this->collForumMessages); $i < $size; $i++) {
					if (($retval = $this->collForumMessages[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed forum_thread_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setForumThreadId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getForumThreadId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return ForumThread Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new ForumThread();
		$copyObj->setForumId($this->forum_id);
		$copyObj->setCreatedBy($this->created_by);
		$copyObj->setThreadName($this->thread_name);
		$copyObj->setMessageCount($this->message_count);
		$copyObj->setMostRecentDate($this->most_recent_date);
		$copyObj->setIsSticky($this->is_sticky);
		$copyObj->setIsLocked($this->is_locked);
		$copyObj->setPageViews($this->page_views);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getForumMessages() as $relObj) {
				$copyObj->addForumMessage($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setForumThreadId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return ForumThreadPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ForumThreadPeer();
		}
		return self::$peer;
	}

}
