<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists Mailman
//
require_once('plugins/mailman/lib/MailmanPeer.php');
require_once('plugins/mailman/lib/Mailman.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/mailman/lib/html/MailmanAdminTemplate.php');
$theme = new MailmanAdminTemplate();

$Project = GFUrl::getUrl()->getProject();

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Mailman.Admin')
		);
$theme->header($params);


// Retrieve the objects array
$crit = new Criteria();
$crit->add(MailmanPeer::PROJECT_ID, $Project->getProjectId());
$arr = MailmanPeer::doSelect($crit);

$theader = array();
	$url = GFUrl::getUrl();

$theader[] = $Lang->getText('Mailman.ListNameName');
$theader[] = $Lang->getText('Edit');
$theader[] = $Lang->getText('Delete');		
$theader[] = $Lang->getText('MailmanAdmin.Administrate');

echo $theme->tableTop($theader);


if (count($arr) < 1) {
	 echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('Mailman.NoneFound').' '.$Project->getName().'</span>');
} else {
	foreach ($arr as $item) {
		$trow = array();	
		$trow[]=$item->getListName();
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('MailmanEdit').'&amp;id='.$item->getMailmanID() .'">'. $Lang->getText('Edit') .'</a>';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('MailmanDelete').'&amp;id='.$item->getMailmanID() .'">'. $Lang->getText('Delete').'</a>';			
		if($item->getStatus() == Mailman::STATUS_REQUESTED) {				
			$trow[]=$Lang->getText('Mailman.NotActivatedYet');
		} else {
			//$trow[]='<a href="http://'.GFConf::get('mailman.listsHost').'/mailman/admin/'.$item->getListName().'/">'.$Lang->getText('MailmanAdmin.Administrate').'</a>';
			$trow[]='<a href="'.$url->buildUrl('/mailman/admin/'.$item->getListName()).'">'.$Lang->getText('MailmanAdmin.Administrate').'</a>';
		}
		echo $theme->tableRow($trow, array(), false);
	}
}

echo $theme->tableBottom(array(GFUrl::getUrl()->currentBaseUrl('MailmanAdd')=>$Lang->getText('Mailman.AddNew')));

$theme->footer($params);
?>
