<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'code_search_index' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.scm.lib.map
 */
class CodeSearchIndexMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.scm.lib.map.CodeSearchIndexMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("code_search_index");
		$tMap->setPhpName("CodeSearchIndex");
		
         
		$tMap->setUseIdGenerator(false);
		 
						
		 
		
		// Add columns to map
		$tMap->addForeignKey("CODE_SEARCH_MODULE_ID", "CodeSearchModuleId", "int", CreoleTypes::INTEGER, "code_search_module" , "CODE_SEARCH_MODULE_ID", true);
		$tMap->addColumn("FILENAME", "Filename", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("LINE", "Line", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addColumn("REVISION", "Revision", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("CLASS_NAME", "ClassName", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("METHOD_NAME", "MethodName", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("VARIABLE_NAME", "VariableName", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("COMMENT", "Comment", "string", CreoleTypes::VARCHAR, false, null);
				
    }
}
