<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'scm_commit_file' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.scm.lib.map
 */
class ScmCommitFileMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.scm.lib.map.ScmCommitFileMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("scm_commit_file");
		$tMap->setPhpName("ScmCommitFile");
		
         
		$tMap->setUseIdGenerator(false);
		 
						
		 
		
		// Add columns to map
		$tMap->addForeignPrimaryKey("SCM_COMMIT_ID", "ScmCommitId", "int" , CreoleTypes::INTEGER, "scm_commit", "SCM_COMMIT_ID", true);
		$tMap->addPrimaryKey("MODIFIED_FILE", "ModifiedFile", "string", CreoleTypes::VARCHAR, true);
		$tMap->addColumn("PREV_VERSION", "PrevVersion", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("NEW_VERSION", "NewVersion", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("CHANGED_LINES", "ChangedLines", "int", CreoleTypes::INTEGER, false, null);
				
    }
}
