<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Project.php';
// (on-demand) include_once 'core/ProjectPeer.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'plugins/scm/lib/ScmUserStatsPeer.php';

/**
 * Base class that represents a row from the 'scm_user_stats' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to ScmUserStats class. 
 * 
 * @package plugins.scm.lib 
 */
abstract class BaseScmUserStats extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var ScmUserStatsPeer
	 */
	protected static $peer;

	/**
	 * The value for the stat_date field.
	 * @var int	  
	 */
	protected $stat_date;	

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

	/**
	 * The value for the user_id field.
	 * @var int	  
	 */
	protected $user_id;	

	/**
	 * The value for the checkouts field.
	 * @var int	  
	 */
	protected $checkouts;	

	/**
	 * The value for the commits field.
	 * @var int	  
	 */
	protected $commits;	

	/**
	 * The value for the adds field.
	 * @var int	  
	 */
	protected $adds;	

	/**
	 * Get the [optionally formatted] `stat_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getStatDate($format = '%x')
	{
		if ($this->stat_date === null || $this->stat_date === '') {
			return null;
		} elseif (!is_int($this->stat_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->stat_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of stat_date as date/time value: " . var_export($this->stat_date, true));
			}
		} else {
			$ts = $this->stat_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `stat_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setStatDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for stat_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->stat_date !== $ts || $ts === -1) {
			$this->stat_date = $ts;
			$this->modifiedColumns[] = ScmUserStatsPeer::STAT_DATE;
		}
		
	}

  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = ScmUserStatsPeer::PROJECT_ID;
		}
			
		if ($this->aProject !== null && $this->aProject->getProjectId() !== $v) {
			$this->aProject = null;
		}
			
	}

  
	/**
	 * Get the UserId column value.
	 *  
	 * @return int	  
	 */
	public function getUserId()
	{
		return $this->user_id;
	}


	/**
	 * Set the value of `user_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setUserId($v)
	{
		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = ScmUserStatsPeer::USER_ID;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}

  
	/**
	 * Get the Checkouts column value.
	 *  
	 * @return int	  
	 */
	public function getCheckouts()
	{
		return $this->checkouts;
	}


	/**
	 * Set the value of `checkouts` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setCheckouts($v)
	{
		if ($this->checkouts !== $v) {
			$this->checkouts = $v;
			$this->modifiedColumns[] = ScmUserStatsPeer::CHECKOUTS;
		}
				
	}

  
	/**
	 * Get the Commits column value.
	 *  
	 * @return int	  
	 */
	public function getCommits()
	{
		return $this->commits;
	}


	/**
	 * Set the value of `commits` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setCommits($v)
	{
		if ($this->commits !== $v) {
			$this->commits = $v;
			$this->modifiedColumns[] = ScmUserStatsPeer::COMMITS;
		}
				
	}

  
	/**
	 * Get the Adds column value.
	 *  
	 * @return int	  
	 */
	public function getAdds()
	{
		return $this->adds;
	}


	/**
	 * Set the value of `adds` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setAdds($v)
	{
		if ($this->adds !== $v) {
			$this->adds = $v;
			$this->modifiedColumns[] = ScmUserStatsPeer::ADDS;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->stat_date = $rs->getDate($startcol + 0, null);
			$this->project_id = $rs->getInt($startcol + 1);					
			$this->user_id = $rs->getInt($startcol + 2);					
			$this->checkouts = $rs->getInt($startcol + 3);					
			$this->commits = $rs->getInt($startcol + 4);					
			$this->adds = $rs->getInt($startcol + 5);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating ScmUserStats object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(ScmUserStatsPeer::DATABASE_NAME);
		$criteria->add(ScmUserStatsPeer::STAT_DATE, $this->stat_date);
		$criteria->add(ScmUserStatsPeer::PROJECT_ID, $this->project_id);
		$criteria->add(ScmUserStatsPeer::USER_ID, $this->user_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(ScmUserStatsPeer::DATABASE_NAME);
		if ($this->isColumnModified(ScmUserStatsPeer::STAT_DATE)) $criteria->add(ScmUserStatsPeer::STAT_DATE, $this->stat_date);
		if ($this->isColumnModified(ScmUserStatsPeer::PROJECT_ID)) $criteria->add(ScmUserStatsPeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(ScmUserStatsPeer::USER_ID)) $criteria->add(ScmUserStatsPeer::USER_ID, $this->user_id);
		if ($this->isColumnModified(ScmUserStatsPeer::CHECKOUTS)) $criteria->add(ScmUserStatsPeer::CHECKOUTS, $this->checkouts);
		if ($this->isColumnModified(ScmUserStatsPeer::COMMITS)) $criteria->add(ScmUserStatsPeer::COMMITS, $this->commits);
		if ($this->isColumnModified(ScmUserStatsPeer::ADDS)) $criteria->add(ScmUserStatsPeer::ADDS, $this->adds);
		return $criteria;			
	}
	
	

	/**
	 * @var Project	  
	 */
	protected $aProject;

	/**
	 * Declares an association between this object and a Project object
	 *
	 * @param Project $v
	 * @return void
	 * @throws PropelException
	 */
	public function setProject($v)
	{
			
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getProjectId());
		}
   
		$this->aProject = $v;
	}


	/**
	 * Get the associated Project object
	 *
	 * @param Connection Optional Connection object.
	 * @return Project The associated Project object.
	 * @throws PropelException
	 */
	public function getProject($con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPeer.php';

		if ($this->aProject === null && ($this->project_id !== null)) {
	
			$this->aProject = ProjectPeer::retrieveByPK($this->project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ProjectPeer::retrieveByPK($this->project_id, $con);
			   $obj->addScmUserStatss($this);
			 */
		}
		return $this->aProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setProjectKey($key)
	{

		$this->setProjectId( (int) $key);			
		
	}

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setUserId(NULL);
		} else {
			$this->setUserId($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->user_id !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->user_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->user_id, $con);
			   $obj->addScmUserStatss($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setUserId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("stat_date", "project_id", "user_id", "checkouts", "commits", "adds", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case ScmUserStatsPeer::STAT_DATE:
				return $this->getStatDate();
				break;
		  
			case ScmUserStatsPeer::PROJECT_ID:
				return $this->getProjectId();
				break;
		  
			case ScmUserStatsPeer::USER_ID:
				return $this->getUserId();
				break;
		  
			case ScmUserStatsPeer::CHECKOUTS:
				return $this->getCheckouts();
				break;
		  
			case ScmUserStatsPeer::COMMITS:
				return $this->getCommits();
				break;
		  
			case ScmUserStatsPeer::ADDS:
				return $this->getAdds();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getStatDate();
				break;
  
			case 1:
				return $this->getProjectId();
				break;
  
			case 2:
				return $this->getUserId();
				break;
  
			case 3:
				return $this->getCheckouts();
				break;
  
			case 4:
				return $this->getCommits();
				break;
  
			case 5:
				return $this->getAdds();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(ScmUserStatsPeer::STAT_DATE, $arr)) $this->setStatDate($arr[ScmUserStatsPeer::STAT_DATE]);
  
		if (array_key_exists(ScmUserStatsPeer::PROJECT_ID, $arr)) $this->setProjectId($arr[ScmUserStatsPeer::PROJECT_ID]);
  
		if (array_key_exists(ScmUserStatsPeer::USER_ID, $arr)) $this->setUserId($arr[ScmUserStatsPeer::USER_ID]);
  
		if (array_key_exists(ScmUserStatsPeer::CHECKOUTS, $arr)) $this->setCheckouts($arr[ScmUserStatsPeer::CHECKOUTS]);
  
		if (array_key_exists(ScmUserStatsPeer::COMMITS, $arr)) $this->setCommits($arr[ScmUserStatsPeer::COMMITS]);
  
		if (array_key_exists(ScmUserStatsPeer::ADDS, $arr)) $this->setAdds($arr[ScmUserStatsPeer::ADDS]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case ScmUserStatsPeer::STAT_DATE:
				$this->setStatDate($value);
				break;
	  
			case ScmUserStatsPeer::PROJECT_ID:
				$this->setProjectId($value);
				break;
	  
			case ScmUserStatsPeer::USER_ID:
				$this->setUserId($value);
				break;
	  
			case ScmUserStatsPeer::CHECKOUTS:
				$this->setCheckouts($value);
				break;
	  
			case ScmUserStatsPeer::COMMITS:
				$this->setCommits($value);
				break;
	  
			case ScmUserStatsPeer::ADDS:
				$this->setAdds($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setStatDate($value);
				break;
  
			case 1:
				$this->setProjectId($value);
				break;
  
			case 2:
				$this->setUserId($value);
				break;
  
			case 3:
				$this->setCheckouts($value);
				break;
  
			case 4:
				$this->setCommits($value);
				break;
  
			case 5:
				$this->setAdds($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(ScmUserStatsPeer::DATABASE_NAME);

		try {
			$con->begin();
			ScmUserStatsPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(ScmUserStatsPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aProject !== null) {
				if ($this->aProject->isModified()) $this->aProject->save($con);
				$this->setProject($this->aProject);
			}
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ScmUserStatsPeer::doInsert($this, $con);
					$this->setNew(false);
				} else {
					ScmUserStatsPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return ScmUserStatsPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aProject !== null) {
				if (($retval = $this->aProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = ScmUserStatsPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  


	private $pks = array();
	
	/**
	 * Set the PrimaryKey.
	 *
	 * @param array $keys The elements of the composite key (order must match the order in XML file).
	 * @return void
	 * @throws PropelException
	 */
	public function setPrimaryKey($keys)
	{						

		$this->setStatDate($keys[0]);

		$this->setProjectId($keys[1]);

		$this->setUserId($keys[2]);

	}


	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return array 
	 */
	public function getPrimaryKey()
	{
		$this->pks[0] = $this->getStatDate();
		$this->pks[1] = $this->getProjectId();
		$this->pks[2] = $this->getUserId();
		return $this->pks;

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return ScmUserStats Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new ScmUserStats();
		$copyObj->setCheckouts($this->checkouts);
		$copyObj->setCommits($this->commits);
		$copyObj->setAdds($this->adds);
		
		$copyObj->setNew(true);
		
		$copyObj->setStatDate(NULL); // this is a pkey column, so set to default value
		$copyObj->setProjectId(NULL); // this is a pkey column, so set to default value
		$copyObj->setUserId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return ScmUserStatsPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ScmUserStatsPeer();
		}
		return self::$peer;
	}

}
