<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/tracker/lib/Tracker.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerPeer.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'plugins/tracker/lib/TrackerQueryPeer.php';

/**
 * Base class that represents a row from the 'tracker_query' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TrackerQuery class. 
 * 
 * @package plugins.tracker.lib 
 */
abstract class BaseTrackerQuery extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TrackerQueryPeer
	 */
	protected static $peer;

	/**
	 * The value for the tracker_query_id field.
	 * @var int	  
	 */
	protected $tracker_query_id;	

	/**
	 * The value for the tracker_id field.
	 * @var int	  
	 */
	protected $tracker_id;	

	/**
	 * The value for the user_id field.
	 * @var int	  
	 */
	protected $user_id;	

	/**
	 * The value for the query_name field.
	 * @var string	  
	 */
	protected $query_name;	

	/**
	 * The value for the is_shared field.
	 * @var boolean	  
	 */
	protected $is_shared = false;	
  
	/**
	 * Get the TrackerQueryId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerQueryId()
	{
		return $this->tracker_query_id;
	}


	/**
	 * Set the value of `tracker_query_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerQueryId($v)
	{
		if ($this->tracker_query_id !== $v) {
			$this->tracker_query_id = $v;
			$this->modifiedColumns[] = TrackerQueryPeer::TRACKER_QUERY_ID;
		}
			
		  // update associated TrackerQueryField		  
		  if ($this->collTrackerQueryFields !== null) {
			  for ($i=0,$size=count($this->collTrackerQueryFields); $i < $size; $i++) {
				  $this->collTrackerQueryFields[$i]->setTrackerQueryId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the TrackerId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerId()
	{
		return $this->tracker_id;
	}


	/**
	 * Set the value of `tracker_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerId($v)
	{
		if ($this->tracker_id !== $v) {
			$this->tracker_id = $v;
			$this->modifiedColumns[] = TrackerQueryPeer::TRACKER_ID;
		}
			
		if ($this->aTracker !== null && $this->aTracker->getTrackerId() !== $v) {
			$this->aTracker = null;
		}
			
	}

  
	/**
	 * Get the UserId column value.
	 *  
	 * @return int	  
	 */
	public function getUserId()
	{
		return $this->user_id;
	}


	/**
	 * Set the value of `user_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setUserId($v)
	{
		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = TrackerQueryPeer::USER_ID;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}

  
	/**
	 * Get the QueryName column value.
	 *  
	 * @return string	  
	 */
	public function getQueryName()
	{
		return $this->query_name;
	}


	/**
	 * Set the value of `query_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setQueryName($v)
	{
		if ($this->query_name !== $v) {
			$this->query_name = $v;
			$this->modifiedColumns[] = TrackerQueryPeer::QUERY_NAME;
		}
				
	}

  
	/**
	 * Get the IsShared column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsShared()
	{
		return $this->is_shared;
	}


	/**
	 * Set the value of `is_shared` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsShared($v)
	{
		if ($this->is_shared !== $v || $v === false) {
			$this->is_shared = $v;
			$this->modifiedColumns[] = TrackerQueryPeer::IS_SHARED;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->tracker_query_id = $rs->getInt($startcol + 0);					
			$this->tracker_id = $rs->getInt($startcol + 1);					
			$this->user_id = $rs->getInt($startcol + 2);					
			$this->query_name = $rs->getString($startcol + 3);					
			$this->is_shared = $rs->getBoolean($startcol + 4);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating TrackerQuery object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(TrackerQueryPeer::DATABASE_NAME);
		$criteria->add(TrackerQueryPeer::TRACKER_QUERY_ID, $this->tracker_query_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(TrackerQueryPeer::DATABASE_NAME);
		if ($this->isColumnModified(TrackerQueryPeer::TRACKER_QUERY_ID)) $criteria->add(TrackerQueryPeer::TRACKER_QUERY_ID, $this->tracker_query_id);
		if ($this->isColumnModified(TrackerQueryPeer::TRACKER_ID)) $criteria->add(TrackerQueryPeer::TRACKER_ID, $this->tracker_id);
		if ($this->isColumnModified(TrackerQueryPeer::USER_ID)) $criteria->add(TrackerQueryPeer::USER_ID, $this->user_id);
		if ($this->isColumnModified(TrackerQueryPeer::QUERY_NAME)) $criteria->add(TrackerQueryPeer::QUERY_NAME, $this->query_name);
		if ($this->isColumnModified(TrackerQueryPeer::IS_SHARED)) $criteria->add(TrackerQueryPeer::IS_SHARED, $this->is_shared);
		return $criteria;			
	}
	
	

	/**
	 * @var Tracker	  
	 */
	protected $aTracker;

	/**
	 * Declares an association between this object and a Tracker object
	 *
	 * @param Tracker $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTracker($v)
	{
			
		if ($v === null) {
			$this->setTrackerId(NULL);
		} else {
			$this->setTrackerId($v->getTrackerId());
		}
   
		$this->aTracker = $v;
	}


	/**
	 * Get the associated Tracker object
	 *
	 * @param Connection Optional Connection object.
	 * @return Tracker The associated Tracker object.
	 * @throws PropelException
	 */
	public function getTracker($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerPeer.php';

		if ($this->aTracker === null && ($this->tracker_id !== null)) {
	
			$this->aTracker = TrackerPeer::retrieveByPK($this->tracker_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerPeer::retrieveByPK($this->tracker_id, $con);
			   $obj->addTrackerQuerys($this);
			 */
		}
		return $this->aTracker;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerKey($key)
	{

		$this->setTrackerId( (int) $key);			
		
	}

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setUserId(NULL);
		} else {
			$this->setUserId($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->user_id !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->user_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->user_id, $con);
			   $obj->addTrackerQuerys($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setUserId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collTrackerQueryFields	  
	 * @var array
	 */
	protected $collTrackerQueryFields; 

	/**
	 * Temporary storage of collTrackerQueryFields to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerQueryFields()
	{
		if ($this->collTrackerQueryFields === null) {
			$this->collTrackerQueryFields = array();
		}
	}

	/**
	 * Method called to associate a TrackerQueryField object to this object
	 * through the TrackerQueryField foreign key attribute
	 *
	 * @param TrackerQueryField $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerQueryField(TrackerQueryField $l)
	{
		$this->collTrackerQueryFields[] = $l;
		$l->setTrackerQuery($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerQueryFields.
	 * @var Criteria
	 */
	private $lastTrackerQueryFieldsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerQuery has previously
	 * been saved, it will retrieve related TrackerQueryFields from storage.
	 * If this TrackerQuery is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerQueryFields($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerQueryFieldPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerQueryFields === null) {
			if ($this->isNew()) {
			   $this->collTrackerQueryFields = array();
			} else {
	
				$criteria->add(TrackerQueryFieldPeer::TRACKER_QUERY_ID, $this->getTrackerQueryId() );

				$this->collTrackerQueryFields = TrackerQueryFieldPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerQueryFieldPeer::TRACKER_QUERY_ID, $this->getTrackerQueryId());

				if (!isset($this->lastTrackerQueryFieldsCriteria) || !$this->lastTrackerQueryFieldsCriteria->equals($criteria)) {
					$this->collTrackerQueryFields = TrackerQueryFieldPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerQueryFieldsCriteria = $criteria;

		return $this->collTrackerQueryFields;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerQuery is new, it will return
	 * an empty collection; or if this TrackerQuery has previously
	 * been saved, it will retrieve related TrackerQueryFields from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerQuery.
	 */
	public function getTrackerQueryFieldsJoinTrackerQuery($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerQueryFieldPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerQueryFields === null) {
			if ($this->isNew()) {
			   $this->collTrackerQueryFields = array();
			} else {
	   
				$criteria->add(TrackerQueryFieldPeer::TRACKER_QUERY_ID, $this->getTrackerQueryId());
				$this->collTrackerQueryFields = TrackerQueryFieldPeer::doSelectJoinTrackerQuery($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerQueryFieldPeer::TRACKER_QUERY_ID, $this->getTrackerQueryId());
			if (!isset($this->lastTrackerQueryFieldsCriteria) || !$this->lastTrackerQueryFieldsCriteria->equals($criteria)) {
				$this->collTrackerQueryFields = TrackerQueryFieldPeer::doSelectJoinTrackerQuery($criteria, $con);
			}
		}
		$this->lastTrackerQueryFieldsCriteria = $criteria;

		return $this->collTrackerQueryFields;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("tracker_query_id", "tracker_id", "user_id", "query_name", "is_shared", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case TrackerQueryPeer::TRACKER_QUERY_ID:
				return $this->getTrackerQueryId();
				break;
		  
			case TrackerQueryPeer::TRACKER_ID:
				return $this->getTrackerId();
				break;
		  
			case TrackerQueryPeer::USER_ID:
				return $this->getUserId();
				break;
		  
			case TrackerQueryPeer::QUERY_NAME:
				return $this->getQueryName();
				break;
		  
			case TrackerQueryPeer::IS_SHARED:
				return $this->getIsShared();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getTrackerQueryId();
				break;
  
			case 1:
				return $this->getTrackerId();
				break;
  
			case 2:
				return $this->getUserId();
				break;
  
			case 3:
				return $this->getQueryName();
				break;
  
			case 4:
				return $this->getIsShared();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(TrackerQueryPeer::TRACKER_QUERY_ID, $arr)) $this->setTrackerQueryId($arr[TrackerQueryPeer::TRACKER_QUERY_ID]);
  
		if (array_key_exists(TrackerQueryPeer::TRACKER_ID, $arr)) $this->setTrackerId($arr[TrackerQueryPeer::TRACKER_ID]);
  
		if (array_key_exists(TrackerQueryPeer::USER_ID, $arr)) $this->setUserId($arr[TrackerQueryPeer::USER_ID]);
  
		if (array_key_exists(TrackerQueryPeer::QUERY_NAME, $arr)) $this->setQueryName($arr[TrackerQueryPeer::QUERY_NAME]);
  
		if (array_key_exists(TrackerQueryPeer::IS_SHARED, $arr)) $this->setIsShared($arr[TrackerQueryPeer::IS_SHARED]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case TrackerQueryPeer::TRACKER_QUERY_ID:
				$this->setTrackerQueryId($value);
				break;
	  
			case TrackerQueryPeer::TRACKER_ID:
				$this->setTrackerId($value);
				break;
	  
			case TrackerQueryPeer::USER_ID:
				$this->setUserId($value);
				break;
	  
			case TrackerQueryPeer::QUERY_NAME:
				$this->setQueryName($value);
				break;
	  
			case TrackerQueryPeer::IS_SHARED:
				$this->setIsShared($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setTrackerQueryId($value);
				break;
  
			case 1:
				$this->setTrackerId($value);
				break;
  
			case 2:
				$this->setUserId($value);
				break;
  
			case 3:
				$this->setQueryName($value);
				break;
  
			case 4:
				$this->setIsShared($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerQueryPeer::DATABASE_NAME);

		try {
			$con->begin();
			TrackerQueryPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerQueryPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aTracker !== null) {
				if ($this->aTracker->isModified()) $this->aTracker->save($con);
				$this->setTracker($this->aTracker);
			}
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TrackerQueryPeer::doInsert($this, $con);
					$this->setTrackerQueryId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					TrackerQueryPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collTrackerQueryFields !== null) {
				for ($i=0,$size=count($this->collTrackerQueryFields); $i < $size; $i++) {
					$this->collTrackerQueryFields[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return TrackerQueryPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aTracker !== null) {
				if (($retval = $this->aTracker->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = TrackerQueryPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collTrackerQueryFields !== null) {
				for ($i=0,$size=count($this->collTrackerQueryFields); $i < $size; $i++) {
					if (($retval = $this->collTrackerQueryFields[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed tracker_query_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setTrackerQueryId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getTrackerQueryId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return TrackerQuery Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new TrackerQuery();
		$copyObj->setTrackerId($this->tracker_id);
		$copyObj->setUserId($this->user_id);
		$copyObj->setQueryName($this->query_name);
		$copyObj->setIsShared($this->is_shared);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getTrackerQueryFields() as $relObj) {
				$copyObj->addTrackerQueryField($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setTrackerQueryId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return TrackerQueryPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TrackerQueryPeer();
		}
		return self::$peer;
	}

}
