<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';

include_once 'plugins/tracker/lib/TrackerTimeCodePeer.php';

/**
 * Base class that represents a row from the 'tracker_time_code' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TrackerTimeCode class. 
 * 
 * @package plugins.tracker.lib 
 */
abstract class BaseTrackerTimeCode extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TrackerTimeCodePeer
	 */
	protected static $peer;

	/**
	 * The value for the tracker_time_code_id field.
	 * @var int	  
	 */
	protected $tracker_time_code_id;	

	/**
	 * The value for the time_name field.
	 * @var string	  
	 */
	protected $time_name;	
  
	/**
	 * Get the TrackerTimeCodeId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerTimeCodeId()
	{
		return $this->tracker_time_code_id;
	}


	/**
	 * Set the value of `tracker_time_code_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerTimeCodeId($v)
	{
		if ($this->tracker_time_code_id !== $v) {
			$this->tracker_time_code_id = $v;
			$this->modifiedColumns[] = TrackerTimeCodePeer::TRACKER_TIME_CODE_ID;
		}
			
		  // update associated TrackerItemTime		  
		  if ($this->collTrackerItemTimes !== null) {
			  for ($i=0,$size=count($this->collTrackerItemTimes); $i < $size; $i++) {
				  $this->collTrackerItemTimes[$i]->setTrackerTimeCodeId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the TimeName column value.
	 *  
	 * @return string	  
	 */
	public function getTimeName()
	{
		return $this->time_name;
	}


	/**
	 * Set the value of `time_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setTimeName($v)
	{
		if ($this->time_name !== $v) {
			$this->time_name = $v;
			$this->modifiedColumns[] = TrackerTimeCodePeer::TIME_NAME;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->tracker_time_code_id = $rs->getInt($startcol + 0);					
			$this->time_name = $rs->getString($startcol + 1);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating TrackerTimeCode object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(TrackerTimeCodePeer::DATABASE_NAME);
		$criteria->add(TrackerTimeCodePeer::TRACKER_TIME_CODE_ID, $this->tracker_time_code_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(TrackerTimeCodePeer::DATABASE_NAME);
		if ($this->isColumnModified(TrackerTimeCodePeer::TRACKER_TIME_CODE_ID)) $criteria->add(TrackerTimeCodePeer::TRACKER_TIME_CODE_ID, $this->tracker_time_code_id);
		if ($this->isColumnModified(TrackerTimeCodePeer::TIME_NAME)) $criteria->add(TrackerTimeCodePeer::TIME_NAME, $this->time_name);
		return $criteria;			
	}
	
	

	/**
	 * Collection to store aggregation of collTrackerItemTimes	  
	 * @var array
	 */
	protected $collTrackerItemTimes; 

	/**
	 * Temporary storage of collTrackerItemTimes to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerItemTimes()
	{
		if ($this->collTrackerItemTimes === null) {
			$this->collTrackerItemTimes = array();
		}
	}

	/**
	 * Method called to associate a TrackerItemTime object to this object
	 * through the TrackerItemTime foreign key attribute
	 *
	 * @param TrackerItemTime $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerItemTime(TrackerItemTime $l)
	{
		$this->collTrackerItemTimes[] = $l;
		$l->setTrackerTimeCode($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerItemTimes.
	 * @var Criteria
	 */
	private $lastTrackerItemTimesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerTimeCode has previously
	 * been saved, it will retrieve related TrackerItemTimes from storage.
	 * If this TrackerTimeCode is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerItemTimes($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemTimePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerItemTimes === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemTimes = array();
			} else {
	
				$criteria->add(TrackerItemTimePeer::TRACKER_TIME_CODE_ID, $this->getTrackerTimeCodeId() );

				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerItemTimePeer::TRACKER_TIME_CODE_ID, $this->getTrackerTimeCodeId());

				if (!isset($this->lastTrackerItemTimesCriteria) || !$this->lastTrackerItemTimesCriteria->equals($criteria)) {
					$this->collTrackerItemTimes = TrackerItemTimePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerItemTimesCriteria = $criteria;

		return $this->collTrackerItemTimes;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerTimeCode is new, it will return
	 * an empty collection; or if this TrackerTimeCode has previously
	 * been saved, it will retrieve related TrackerItemTimes from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerTimeCode.
	 */
	public function getTrackerItemTimesJoinTrackerItem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemTimePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemTimes === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemTimes = array();
			} else {
	   
				$criteria->add(TrackerItemTimePeer::TRACKER_TIME_CODE_ID, $this->getTrackerTimeCodeId());
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemTimePeer::TRACKER_TIME_CODE_ID, $this->getTrackerTimeCodeId());
			if (!isset($this->lastTrackerItemTimesCriteria) || !$this->lastTrackerItemTimesCriteria->equals($criteria)) {
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		}
		$this->lastTrackerItemTimesCriteria = $criteria;

		return $this->collTrackerItemTimes;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerTimeCode is new, it will return
	 * an empty collection; or if this TrackerTimeCode has previously
	 * been saved, it will retrieve related TrackerItemTimes from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerTimeCode.
	 */
	public function getTrackerItemTimesJoinTrackerTimeCode($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemTimePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemTimes === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemTimes = array();
			} else {
	   
				$criteria->add(TrackerItemTimePeer::TRACKER_TIME_CODE_ID, $this->getTrackerTimeCodeId());
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinTrackerTimeCode($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemTimePeer::TRACKER_TIME_CODE_ID, $this->getTrackerTimeCodeId());
			if (!isset($this->lastTrackerItemTimesCriteria) || !$this->lastTrackerItemTimesCriteria->equals($criteria)) {
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinTrackerTimeCode($criteria, $con);
			}
		}
		$this->lastTrackerItemTimesCriteria = $criteria;

		return $this->collTrackerItemTimes;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerTimeCode is new, it will return
	 * an empty collection; or if this TrackerTimeCode has previously
	 * been saved, it will retrieve related TrackerItemTimes from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerTimeCode.
	 */
	public function getTrackerItemTimesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemTimePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemTimes === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemTimes = array();
			} else {
	   
				$criteria->add(TrackerItemTimePeer::TRACKER_TIME_CODE_ID, $this->getTrackerTimeCodeId());
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemTimePeer::TRACKER_TIME_CODE_ID, $this->getTrackerTimeCodeId());
			if (!isset($this->lastTrackerItemTimesCriteria) || !$this->lastTrackerItemTimesCriteria->equals($criteria)) {
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastTrackerItemTimesCriteria = $criteria;

		return $this->collTrackerItemTimes;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("tracker_time_code_id", "time_name", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case TrackerTimeCodePeer::TRACKER_TIME_CODE_ID:
				return $this->getTrackerTimeCodeId();
				break;
		  
			case TrackerTimeCodePeer::TIME_NAME:
				return $this->getTimeName();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getTrackerTimeCodeId();
				break;
  
			case 1:
				return $this->getTimeName();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(TrackerTimeCodePeer::TRACKER_TIME_CODE_ID, $arr)) $this->setTrackerTimeCodeId($arr[TrackerTimeCodePeer::TRACKER_TIME_CODE_ID]);
  
		if (array_key_exists(TrackerTimeCodePeer::TIME_NAME, $arr)) $this->setTimeName($arr[TrackerTimeCodePeer::TIME_NAME]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case TrackerTimeCodePeer::TRACKER_TIME_CODE_ID:
				$this->setTrackerTimeCodeId($value);
				break;
	  
			case TrackerTimeCodePeer::TIME_NAME:
				$this->setTimeName($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setTrackerTimeCodeId($value);
				break;
  
			case 1:
				$this->setTimeName($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerTimeCodePeer::DATABASE_NAME);

		try {
			$con->begin();
			TrackerTimeCodePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerTimeCodePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TrackerTimeCodePeer::doInsert($this, $con);
					$this->setTrackerTimeCodeId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					TrackerTimeCodePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collTrackerItemTimes !== null) {
				for ($i=0,$size=count($this->collTrackerItemTimes); $i < $size; $i++) {
					$this->collTrackerItemTimes[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return TrackerTimeCodePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  

			if (($retval = TrackerTimeCodePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collTrackerItemTimes !== null) {
				for ($i=0,$size=count($this->collTrackerItemTimes); $i < $size; $i++) {
					if (($retval = $this->collTrackerItemTimes[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed tracker_time_code_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setTrackerTimeCodeId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getTrackerTimeCodeId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return TrackerTimeCode Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new TrackerTimeCode();
		$copyObj->setTimeName($this->time_name);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getTrackerItemTimes() as $relObj) {
				$copyObj->addTrackerItemTime($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setTrackerTimeCodeId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return TrackerTimeCodePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TrackerTimeCodePeer();
		}
		return self::$peer;
	}

}
