<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists TrackerExtraField
//
require_once('plugins/tracker/lib/TrackerExtraFieldPeer.php');
require_once('plugins/tracker/lib/TrackerExtraField.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerAdminTemplate.php');
$theme = new TrackerAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$Tracker = TrackerPeer::retrieveByPk($_REQUEST['tracker_id']);
if (!is_object($Tracker) || !$Tracker->userIsAdmin() || 
	$Tracker->getProject()->getProjectId() != $Project->getProjectId()) {
	throw new PermissionDeniedException();
}

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'action' => isset($action) ? $action : '',
		'feedback' => (isset($_REQUEST['feedback'])) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('TrackerExtraField.BrowsePageTitle')
		);
$theme->header($params);


echo '<script type="text/javascript" src="/prototype.js"></script>';
echo '<script type="text/javascript" src="/scriptaculous.js"></script>';

// Retrieve the objects array
$crit = new Criteria();
$crit->add(TrackerExtraFieldPeer::TRACKER_ID, $Tracker->getTrackerId());
$crit->addAscendingOrderByColumn(TrackerExtraFieldPeer::FIELD_ORDER);
$arr = TrackerExtraFieldPeer::doSelect($crit);

echo '<p><div class="infobox">'.$Lang->getText('Tracker.AutoAssignDescription').'<br />'.$Lang->getText('Tracker.TransitionCommitRulesDescription').'</div></p>';

$theader = array();

$theader[] = $Lang->getText('TrackerExtraField.FieldNameName');
$theader[] = $Lang->getText('TrackerExtraField.FieldTypeName');
$theader[] = $Lang->getText('TrackerExtraField.AutoAssign');
$theader[] = $Lang->getText('TrackerExtraField.UseWorkFlow');
$theader[] = $Lang->getText('TrackerExtraField.UseCommitRule');
$theader[] = $Lang->getText('TrackerExtraField.IsRequiredName');
$theader[] = $Lang->getText('TrackerExtraField.ShowOnSubmitName');
$theader[] = $Lang->getText('TrackerExtraField.UseInQuickBrowseName');
$theader[] = $Lang->getText('TrackerExtraField.FieldOrder');
$theader[] = $Lang->getText('Edit');
$theader[] = $Lang->getText('Delete');
$theader[] = $Lang->getText('TrackerExtraFieldElement.Edit');

?>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('TrackerExtraFieldBrowseAction') ?>" method="post">
<input type="hidden" name="tracker_id" value="<?php echo $Tracker->getTrackerId(); ?>" />
<?php
echo $theme->tableTop($theader,false,'class="jsSortTBL"');
if (count($arr) < 1) {
	echo $theme->tableFullRow($Lang->getText('TrackerExtraField.NoneFound'));
} else {
	//these vars are used to determine if any field has workflow or auto-assign
	//if not, then the bottom row is set to true
	$was_auto_assign=false;
//	$was_workflow=false;
//	$was_commit_rule=false;

	//Some of the columns of checkboxes are disabled in Express, nothing is disabled in AS
	if (GFConf::get('system.licenseType')=='advanced') {
		$disable_str_1='';
	} else {
		$disable_str_1=' disabled="disabled"';
	}
	if (GFConf::get('system.licenseType')=='community') {
		$disable_str_2=' disabled="disabled"';
	} else {
		$disable_str_2='';
	}
	

	echo '<tbody id="jsExtraFieldList">';
	foreach ($arr as $item) {
		$trow = array();
		$tmod = array();

		$trow[]=$item->getFieldName();
		$tmod[]='class="moveHandle"';
		$trow[]=$Lang->getText('TrackerExtraField.FieldType'.$item->getFieldType());
		$tmod[]='';

		if ($item->getFieldType() == TrackerExtraField::TYPE_STATUS 
			|| $item->getFieldType() == TrackerExtraField::TYPE_RADIO
			|| $item->getFieldType() == TrackerExtraField::TYPE_SELECT) {
			if ($item->getUseAutoAssign()) {
				$was_auto_assign=true;
			}
			$trow[]='<input type="radio" name="auto_assign_to" value="'.$item->getTrackerExtraFieldID().'" '.(( $item->getUseAutoAssign()) ? 'checked="checked"' : '').$disable_str_1.'/>';
			$tmod[]='';
		} else {
			$trow[]='&nbsp;';
			$tmod[]='';
		}
		if ($item->getFieldType() == TrackerExtraField::TYPE_STATUS 
			|| $item->getFieldType() == TrackerExtraField::TYPE_RADIO
			|| $item->getFieldType() == TrackerExtraField::TYPE_SELECT) {
			$contents = '<input type="checkbox" name="use_workflow['.$item->getTrackerExtraFieldID().']" value="1" '.(( $item->getUseWorkFlow()) ? 'checked="checked"' : '').$disable_str_1.'/>';
			if ($item->getUseWorkflow()) {
				$contents .= ' <a href="'.GFUrl::getUrl()->currentBaseUrl('WorkflowMatrix', array('tracker_extra_field_id' => $item->getTrackerExtraFieldId())).'">'.$Lang->getText('WorkflowMatrix.Define').'</a>';
			}
			$trow[]=$contents;
			$tmod[]='';
		} else {
			$trow[]='&nbsp;';
			$tmod[]='';
		}
		if ($item->getFieldType() == TrackerExtraField::TYPE_STATUS 
			|| $item->getFieldType() == TrackerExtraField::TYPE_RADIO
			|| $item->getFieldType() == TrackerExtraField::TYPE_SELECT) {
			$str = '<input type="checkbox" name="use_commit_rule['.$item->getTrackerExtraFieldID().']" value="1" '.(( $item->getUseCommitRule()) ? 'checked="checked"' : '').$disable_str_1.'/>';
			if ($item->getUseCommitRule()) {
				$url = GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldElementBrowse', array('tracker_extra_field_id' => $item->getTrackerExtraFieldID(), 'tracker_id' => $item->getTrackerID()));
				$str .= ' <a href="'.$url.'">'.$Lang->getText('TrackerExtraField.DefineCommitRules').'</a>';
			}
			
			$trow[]=$str;
			$tmod[]='';
		} else {
			$trow[]='&nbsp;';
			$tmod[]='';
		}
		// Serial fields dont use is_required
  		if($item->getFieldType() == TrackerExtraField::TYPE_SERIAL){
  			$trow[]='&nbsp';
  			$tmod[]='';
  		} else {
			$trow[]='<input type="checkbox" name="is_required['.$item->getTrackerExtraFieldID().']" '.(($item->getIsRequired()) ? 'checked="checked"' : '' ).'" size="3" maxlength="3" '.$disable_str_2.'/>';
			$tmod[]='';
		}
		//A serial field can't be shown on submit
		if($item->getFieldType() == TrackerExtraField::TYPE_SERIAL){
  			$trow[]='&nbsp';
  			$tmod[]='';
  		} else { 
			$trow[]='<input type="checkbox" name="show_on_submit['.$item->getTrackerExtraFieldID().']" '.(($item->getShowOnSubmit()) ? 'checked="checked"' : '' ).'" size="3" maxlength="3" '.$disable_str_2.'/>';
		}
		$trow[]='<input type="checkbox" name="show_on_browse['.$item->getTrackerExtraFieldID().']" '.(($item->getUseInQuickBrowse()) ? 'checked="checked"' : '' ).'" size="3" maxlength="3" '.$disable_str_2.'/>';
		$tmod[]='';
		$trow[]='<input type="text" id="EFOrder'.$item->getTrackerExtraFieldID().'" name="field_order['.$item->getTrackerExtraFieldID().']" value="'.$item->getFieldOrder().'" size="3" maxlength="3" />';
		$tmod[]='';
		if ($item->getFieldType() == TrackerExtraField::TYPE_STATUS) {
			$trow[]='&nbsp;';
			$tmod[]='';
			$trow[]='&nbsp;';
			$tmod[]='';
		} elseif ($item->getAlias() == 'duration' 
			|| $item->getAlias() == 'percentcomplete' 
			|| $item->getAlias() == 'estimatedeffort'
			//|| $item->getAlias() == 'foundinrelease'
			//|| $item->getAlias() == 'fixedinrelease'
) {
			$trow[]='&nbsp;';
			$tmod[]='';
			$trow[]='&nbsp;';
			$tmod[]='';
		} else {
			$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldEdit').'&amp;tracker_id='.$item->getTrackerID().'&amp;tracker_extra_field_id='.$item->getTrackerExtraFieldID() .'">'. $Lang->getText('Edit') .'</a>';
			$tmod[]='';
			$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldDelete').'&amp;tracker_id='.$item->getTrackerID().'&amp;tracker_extra_field_id='.$item->getTrackerExtraFieldID() .'">'. $Lang->getText('Delete') .'</a>';
			$tmod[]='';
		}

		$strtype="".$item->getFieldType()."";
		if (strpos(TrackerExtraField::EDITABLE_ELEMENT_TYPES,$strtype) === false) {
			$trow[]='&nbsp;';
			$tmod[]='';
		} else {
			$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldElementBrowse').'&amp;tracker_extra_field_id='.$item->getTrackerExtraFieldID().'&amp;tracker_id='.$item->getTrackerID() .'">'. $Lang->getText('TrackerExtraFieldElement.Edit') .'</a>';
			$tmod[]='';
		}
		echo $theme->tableRow($trow, $tmod, false, 'id="jsExtraFieldList_EFOrder'.$item->getTrackerExtraFieldID().'"');
	}
	echo '</tbody>';

	$trow = array ($Lang->getText('TrackerExtraField.AutoAssignDont'),'&nbsp;','<input type="radio" name="auto_assign_to" value="" '.(($was_auto_assign) ? '' : 'checked="checked"').'/>','&nbsp;','&nbsp;','&nbsp;','&nbsp;','&nbsp;','&nbsp;','&nbsp;','&nbsp;','&nbsp;');
	echo $theme->tableRow($trow);

}
echo $theme->tableBottom();
?><br />
<?php echo HTMLWidget::button("submit", $Lang->getText('Common.Submit')); ?>

<?php
echo '<br />';
echo '<br />';
echo '<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldAdd').'&amp;tracker_id='.$Tracker->getTrackerID().'&amp;field_type='.TrackerExtraField::TYPE_CHECKBOX .'">'. $Lang->getText('TrackerExtraField.AddCheckbox') .'</a><br />';
echo '<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldAdd').'&amp;tracker_id='.$Tracker->getTrackerID().'&amp;field_type='.TrackerExtraField::TYPE_MULTISELECT .'">'. $Lang->getText('TrackerExtraField.AddMultiSelect') .'</a><br />';
echo '<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldAdd').'&amp;tracker_id='.$Tracker->getTrackerID().'&amp;field_type='.TrackerExtraField::TYPE_SELECT .'">'. $Lang->getText('TrackerExtraField.AddSelect') .'</a><br />';
echo '<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldAdd').'&amp;tracker_id='.$Tracker->getTrackerID().'&amp;field_type='.TrackerExtraField::TYPE_RADIO .'">'. $Lang->getText('TrackerExtraField.AddRadio') .'</a><br />';
echo '<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldAdd').'&amp;tracker_id='.$Tracker->getTrackerID().'&amp;field_type='.TrackerExtraField::TYPE_TEXT .'">'. $Lang->getText('TrackerExtraField.AddTextField') .'</a><br />';
echo '<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldAdd').'&amp;tracker_id='.$Tracker->getTrackerID().'&amp;field_type='.TrackerExtraField::TYPE_TEXTAREA .'">'. $Lang->getText('TrackerExtraField.AddTextArea') .'</a><br />';
echo '<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldAdd').'&amp;tracker_id='.$Tracker->getTrackerID().'&amp;field_type='.TrackerExtraField::TYPE_RELEASE .'">'. $Lang->getText('TrackerExtraField.AddRelease') .'</a><br />';
echo '<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldAdd').'&amp;tracker_id='.$Tracker->getTrackerID().'&amp;field_type='.TrackerExtraField::TYPE_DATE .'">'. $Lang->getText('TrackerExtraField.AddDate') .'</a><br />';
echo '<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldAdd').'&amp;tracker_id='.$Tracker->getTrackerID().'&amp;field_type='.TrackerExtraField::TYPE_NUMERIC .'">'. $Lang->getText('TrackerExtraField.AddNumeric') .'</a><br />';

// Add Serial Field
echo '<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldAdd').'&amp;tracker_id='.$Tracker->getTrackerID().'&amp;field_type='.TrackerExtraField::TYPE_SERIAL . '">' . $Lang->getText('TrackerExtraField.AddSerial'). '</a><br />';

// Add Multi Select member
echo '<a href="' . GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldAdd').'&amp;tracker_id='.$Tracker->getTrackerID().'&amp;field_type='.TrackerExtraField::TYPE_MEMBERS . '">' . $Lang->getText('TrackerExtraField.AddMembers') . '</a><br />';
?>

<script type="text/javascript">

function updateOrder() {
	arrayEF = Sortable.serialize('jsExtraFieldList').split('&');
	for (i=0;i<arrayEF.length;i++) {
		efKeyVal = arrayEF[i].split('=');
		obj = FindObject(efKeyVal[1]);
		if (obj) obj.value = i;
	}
	return true;
}

Sortable.create("jsExtraFieldList", {
	dropOnEmpty:true,
	handle:'moveHandle',
	containment:["jsExtraFieldList"],
	constraint:false,
	tag:'tr',
	onUpdate:updateOrder
	}
);
window.onload=window.onload=function(){oldload();convertTrees();window.setTimeout('expandableExpandItem()',100);docmanExpandTree();updateOrder();}
</script>
<?php
$theme->footer($params);
?>
