<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-13
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once ("lib/external/jpgraph/jpgraph.php");
require_once ("lib/external/jpgraph/jpgraph_bar.php");

$session = Session::getSession();
$Lang = $session->getLanguage();
$user = $session->getUser();

$Project = GFUrl::getUrl()->getProject();
$project_id = $Project->getProjectId();

$con = Propel::getConnection(TrackerPeer::DATABASE_NAME);
$stmt = $con->createStatement();

$subprojects=((isset($_REQUEST['subprojects'])) ? Validator::sanitizeInt($_REQUEST['subprojects']) : 0 );
// Get all valid Project Ids
$all_ids = array();
if ($subprojects == 1) {
	$all_ids = $Project->getAllSubprojectIds();
	$all_ids[] = $project_id;
} else {
	$all_ids[] = $project_id;
}

if (!isset($_GET['tracker_id']) || $_GET['tracker_id'] == 0) {
	$sqlaux = " t.project_id IN (".implode(',',$all_ids).") ";
} else {
	$sqlaux = " t.tracker_id = '".$_GET['tracker_id']."'";
}

$sqlmine = '';
$sqlmytable = '';
$user_id=((isset($_REQUEST['user_id'])) ? Validator::sanitizeInt($_REQUEST['user_id']) : 0 );
$priority=((isset($_REQUEST['priority'])) ? Validator::sanitizeInt($_REQUEST['priority']) : 0 );
$status = ((isset($_REQUEST['status'])) ? Validator::sanitizeInt($_REQUEST['status']) : 0 );

if ($user_id) {
	$sqlmine = "AND tia.tracker_item_id=ti.tracker_item_id
	AND (ti.submitted_by = $user_id
	OR tia.assignee=$user_id)";

	$sqlmytable = ', tracker_item_assignee tia ';
}

// If there's a valid project_id, we'll filter by project all the queries


if ($priority)	{
	$sqlmine .= " AND ti.priority = $priority";	
}

if ($status > 0)	{
	$sqlmine .= " AND ti.status_id = " . ($status - 1);	
}

$sql = "SELECT date_part('year', ti.close_date)::text || '-' || date_part('month', ti.close_date)::text AS month,
	date_trunc('day',avg(ti.close_date-ti.open_date)) AS avg,
	count(*) as count
	FROM tracker_item ti, tracker t $sqlmytable
	WHERE 
	$sqlaux
	AND t.datatype='".Tracker::DATATYPE_TRACKER."'
	AND t.tracker_id = ti.tracker_id
	$sqlmine
	GROUP BY month ORDER BY month;";


$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

//Build an array of the last 18 months in YYYY-MM format
$months=array();
$startdate=(time()-1.5*365*60*60*24);
$addmonth=intval(date('m',$startdate));
$startyear=intval(date('Y',$startdate));
$addyear=0;
$months["".($startyear+$addyear).'-'.($addmonth).""]=0;
for ($i=0; $i<18; $i++) {
	$addmonth++;
	if ($addmonth > 12) {
		$addmonth=1;
		$addyear++;
	}
	$months["".($startyear+$addyear).'-'.($addmonth).""]=0;
}

$data=array();
$lastYear=0;
$i = -1;
if ($rs != null && $rs->getRecordCount() > 0) {
	while($rs->next()) {
		if (isset($months[$rs->getString('month')])) {
			$avg=$rs->getString('avg');
			$avg_arr=explode(' ',$avg);
			if (count($avg_arr) < 2) {
				$avg=0;
			} else {
				$avg=$avg_arr[0];
			}
			$months[$rs->getString('month')] = $avg;
		}
	}
}
$font = $Lang->getFontProperties(FF_FONT1, FS_NORMAL, 12);
// Create the graph. These two calls are always required
$graph = new Graph(400, 250);
$graph->title->Set($Lang->getText('TrackerReporting.AverageAge'));
$graph->title->SetFont($font[0], $font[1], $font[2]);
$graph->SetScale('textlin');
$graph->setBox(false);
$graph->setFrame(false);
$graph->img->SetMargin(40,20,30,50);
$graph->yaxis->scale->SetGrace(0);
$graph->yaxis->SetLabelMargin(1);
$graph->yaxis->SetTitle('Days', 'low');
$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->yaxis->SetTitleMargin(30);
$graph->xaxis->SetTickLabels(array_keys($months));
$graph->xaxis->SetLabelAngle(90);

$b = new BarPlot(array_values($months));
$b->value->Show();
$b->value->SetFormat('%d');
$b->SetAbsWidth(15);
$b->SetWidth(1);

$graph->Add($b);
$graph->Stroke();
?>
 