<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/SiteTemplate.php');
require_once('Validator.php');

$session = Session::getSession();
if ($session->isLoggedIn()) {
	// if user is already logged in, go to the logout page
	$url = GFUrl::getUrl();
	$url->redirect($url->baseUrl('Logout', '', '/account'));
}

$template = new SiteTemplate();
$params = array(
		'selectedtoptab' => 'my',
		'title' => Language::getSessText('Common.Login'),
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	);
$template->header($params);

if (isset($_POST) && isset($_POST['username'])) {
	$username = Validator::sanitizeString($_POST['username']);
} else {
	$username = '';
}

if (isset($_REQUEST['redirect']) && !empty($_REQUEST['redirect'])){
	if (Validator::validateRedirect($_REQUEST['redirect'])) {
		$redirect = $_REQUEST['redirect']; 
	}else{
		throw new Exception('Invalid URL');
	}
}else{
	$redirect = '';
}

//sso begin
if (GFConf::get('system.useSSO')) {
	if (isset($_SERVER[GFConf::get('system.SSOServerVar')])) {
		$url = GFUrl::getUrl();
		$params = array();
		if (isset($redirect)) {
			$params['redirect'] = urlencode($redirect);
		}
		$url->redirect($url->baseUrl('LoginAction', '', '/account'), $params);
	} else {
		throw new Exception('Must login with SSO first');
	}
}
//sso end
?>

<form action="<?php echo GFUrl::getUrl()->currentBaseURL('LoginAction') ?>" method="POST" />
<input type="hidden" name="redirect" value="<?php echo $redirect; ?>" />
	<table border="0" cellspacing="7">
	<tr>
		<td>User name</td>
		<td><input type="text" name="username" value="<?php echo $username ?>" /></td>
	</tr>
	<tr>
		<td>Password</td>
		<td><input type="password" name="password" value="" /></td>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<td><?php echo HTMLWidget::button("submit", Language::getSessText('Common.Login') ,"submit","","")?></td>
	</tr>
	</table>
	<a href="<?php echo GFUrl::getUrl()->baseUrl('ResendConfirmation','','account'); ?>"><?php echo Language::getSessText('User.ResendConfirmation'); ?></a>&nbsp;|&nbsp;<a href="<?php echo GFUrl::getUrl()->baseUrl('LostPassword','','account'); ?>"><?php echo Language::getSessText('User.LostYourPasswordLink'); ?></a>&nbsp;|&nbsp;<a href="<?php echo GFUrl::getUrl()->baseURL('UserAdd','','account');?>"><?php echo $language->getText('Common.NewAccount'); ?></a>

</form>

<?php
$template->footer();
?>
