<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$errors = array();

if ((!isset($_POST['loginname']))) {
	$errors[] = Language::getSessText('LostPass.NotEmpty');
} 

if(count($errors) == 0) {
	$loginname = $_POST['loginname'];

	$c = new Criteria();
	$c->add(UserPeer::UNIX_NAME,$loginname);
	$user = UserPeer::doSelectOne($c);
	if ((!$user) || (!is_object($user))) {
		$errors[] = Language::getSessText('LostPass.NotExists');
	}
}

if (count($errors) == 0){
	if ($user->getStatus() == User::STATUS_PENDING) {
		$errors[] = Language::getSessText('LostPass.NotActive');
	} else if ($user->getStatus() != User::STATUS_ACTIVE) {
		$errors[] = Language::getSessText('LostPass.NotExists');
	}
}

if(count($errors) == 0) {	
	$confirm_hash = md5(Session::getSession()->getSessionHash() . strval(time()) . strval(rand())); // First, we need to create new confirm hash
	$user->setConfirmHash($confirm_hash);
	$user->save();
		
	$url = GFUrl::getFullUrl( GFUrl::getUrl()->baseURL('lostlogin','','account',array('confirm_hash'=>$confirm_hash)), true);
	$message = stripcslashes(Language::getSessText('LostPass.Message',array($url,GFConf::get('system.hostName'))));
	SystemUtils::sendMail(Language::getSessText('LostPass.Subject',array(GFConf::get('system.hostName'))),$message,$user->getEmail());
}

if(count($errors) == 0) {
	$feedback = Language::getSessText('LostPass.Notify');
	include('LostPassword.php');
} else {
	$feedback = implode('<br />', $errors);
	include('LostPassword.php');
}
?>