<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-23
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('core/User.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
} else if (!isset($_POST['project_id'])) {
	throw new PermissionDeniedException();
}

if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$User = $session->getUser();

$errors = array();
$Lang = Language::getSessLang();
		
if (count($errors) == 0) {
	if (array_key_exists('sure',$_POST)) {
		// remove the user from the project
		$user_id = $User->getUserId();
		$c = new Criteria();
		$c->add(UserProjectPeer::USER_ID, $user_id);
		$c->add(UserProjectPeer::PROJECT_ID, $_POST['project_id']);
		$user_project = UserProjectPeer::doSelectOne($c);
		if (is_object($user_project)) {
			$user_project->delete();
			$feedback = $Lang->getText('MyUserRemoveFromProject.ConfirmMsg');
		} else {
			$errors++;
			$feedback = $Lang->getText('MyUserRemoveFromProject.ErrorMsg');
		}
	} else {
		$feedback = $Lang->getText('Common.NoChanges');
	}

}

$url = GFUrl::getUrl();
GFUrl::redirect($url->currentBaseURL('UserBrowse'), array('feedback' => $feedback));
?>
