<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/MyTemplate.php');
require_once('lib/core/FilesystemPeer.php');
require_once('lib/core/UserProjectPeer.php');
require_once('plugins/tracker/lib/TrackerMyQueuePeer.php');
require_once('core/ProjectJoinRequestPeer.php');
require_once('core/ProjectJoinRequest.php');

$session = Session::getSession();
if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$User = $session->getUser();
$Lang = $session->getLanguage();

$template = new MyTemplate();
if(isset($_REQUEST['feedback'])) $feedback = $_REQUEST['feedback'];
$params = array(
	'title' => $Lang->getText('My.MyPage'),
	'selectedbottomtab' => 'my',
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'action' => isset($action) ? $action : '',
	'user' =>$User
	);
$tabbertabsetcookie='myindex';
$template->header($params);

// Get the list of queued tracker items
$crit = new Criteria();
$crit->add(TrackerMyQueuePeer::USER_ID, $User->getUserId());
$crit->addAscendingOrderByColumn(TrackerMyQueuePeer::SORT_ORDER);
$MyQueuedItems = TrackerMyQueuePeer::doSelect($crit);
?>
<script type="text/javascript" src="/prototype.js"></script>
<script type="text/javascript" src="/scriptaculous.js"></script>
<script type="text/javascript">
var jsBlockLink = false;
var jsQueueTrackerItems = new Array();
var jsPreviousTrackerItemIds = new Array();
<?php
// Add Tracker Item Ids (in the format needed here) to the JavaScript code
foreach ($MyQueuedItems as $QueuedItem) {
	echo "jsPreviousTrackerItemIds.push('jsTrackerItemId_".$QueuedItem->getTrackerItemId()."');\n";
}
?>

function doUnblockLink() { jsBlockLink = false; }
function doBlockLink() { jsBlockLink = true; }

function linkWatch(url) {
	if (jsBlockLink){ 
		jsBlockLink = false;
		return false;
	} else {
		return true;
	}
}

function addToQueue(element) {
	jsBlockLink = true;
	alreadyAdded = false;
	for (i=0;i<jsQueueTrackerItems.length;i++) {
		if (jsQueueTrackerItems[i].innerHTML == element.innerHTML) {
			alert('<?php echo $Lang->getText('TrackerMyQueue.AlreadyInQueue'); ?>');
			jsBlockLink = true;
			alreadyAdded = true;
			break;
		}
	}
	if (!alreadyAdded) {
		jsQueueTrackerItems.push(element);
		updateQueueList();
	}
}

function removeFromQueue(elementId) {
	newList = new Array();
	for (i=0;i<jsQueueTrackerItems.length;i++) {
		if (jsQueueTrackerItems[i].id != elementId) {
			newList.push(jsQueueTrackerItems[i]);
		}
	}
	jsQueueTrackerItems = newList;
	updateQueueList();
}

function updateQueueList() {
	queueDiv = FindObject("jsTrackerQueue"); // Queue Container
	oldItemList = FindObject("jsTrackerItemList"); // Old Queue List
	oldSeparator = FindObject("jsSeparator"); // Old Separator
	queueDiv.removeChild(oldItemList); // Remove Old Queue List
	queueDiv.removeChild(oldSeparator); // Remove Old Separator

	itemList = document.createElement("div"); // New Queue List
	itemList.id = "jsTrackerItemList";
	separator = document.createElement("div"); // Separator
	separator.id = "jsSeparator";
	separator.style.height = '16px';
	
	if (jsQueueTrackerItems.length == 0) {
		itemList.innerHTML = '&nbsp;&nbsp;<?php echo $Lang->getText('TrackerMyQueue.DragItemsHere'); ?>';
	} else  {
		myHTML = '';
		for (i=0;i<jsQueueTrackerItems.length;i++) {
			myId = jsQueueTrackerItems[i].id.split('_');
			myClass = (i % 2) ? 'jsItemB' : 'jsItemA';
			myPriority = FindObject('jsPriorityItemId_' + myId[1]);
			myHTML += '<div id="ulTrackerList_ulTrackerList'+myId[1]+'" class="moveHandle" style="clear:both;">' +
						'<input name="queuedTrackerItems[]" type="hidden" value="'+myId[1]+'">' +
						'<table cellspacing="0" cellpadding="0" border="0" class="jsTrackerQueueTable"><tr>' +
							'<td class="'+myClass+' jsRBorder jsTrackerQueueColId">'+myId[1]+'</td>' +
						    '<td class="'+myClass+' jsRBorder jsTrackerQueueColName">'+jsQueueTrackerItems[i].innerHTML+'</td>' +
						    '<td class="'+myClass+' jsRBorder jsTrackerQueueColPriority" style="background-color: '+myPriority.bgColor+';">'+myPriority.innerHTML+'&nbsp;&nbsp;</td>' +
						    '<td class="'+myClass+' jsTrackerQueueColRemove"><a href="javascript:void(0)" onClick="removeFromQueue(\''+jsQueueTrackerItems[i].id+'\')"><?php echo $Lang->getText('TrackerMyQueue.Remove'); ?></a></td>' +
					    '</tr></table>' +
					  "</div>\n";
		}
		itemList.innerHTML = myHTML;
	}
	queueDiv.appendChild(itemList); // Add New Queue List
	queueDiv.appendChild(separator);
	Sortable.create("jsTrackerItemList", {dropOnEmpty:true,containment:["jsTrackerItemList"], handle:'moveHandle', tag:'div',constraint:false,onUpdate:doBlockLink});
}

function doPreviouslyQueued() {
	for(i=0;i<jsPreviousTrackerItemIds.length;i++) {
		tempObj = FindObject(jsPreviousTrackerItemIds[i]);
		if (tempObj) {
			jsQueueTrackerItems.push(tempObj);
		}
	}
	updateQueueList();
}
</script>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('MyQueueUpdateAction') ?>" method="POST">
<p>
<h3><?php echo $Lang->getText('TrackerMyQueue.MyQueue'); ?></h3>
</p>
<p>
<div class="tabber">
<?php echo '<div class="tabbertab'. ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='myqueue') ? ' tabbertabdefault' : '') .'" title="'. $Lang->getText('TrackerMyQueue.MyQueue') . '" id="myqueuetab">'; ?>
<div id="jsTrackerQueue" class="jsTrackerQueue">
	<div class="listviewheader" style="padding: 0px;height:30px;overflow:hidden;">
		<table cellspacing="0" cellpadding="0" border="0" class="jsTrackerQueueTable" style="height:20px;"><tr>
			<td class="jsTrackerQueueTitle jsRBorder jsTrackerQueueColId"><?php echo $Lang->getText('Common.Id');?></td>
			<td class="jsTrackerQueueTitle jsRBorder jsTrackerQueueColName"><?php echo $Lang->getText('TrackerItem.SummaryName'); ?></td>
			<td class="jsTrackerQueueTitle jsRBorder jsTrackerQueueColPriority"><?php echo $Lang->getText('TrackerItem.PriorityName'); ?></td>
			<td class="jsTrackerQueueTitle jsTrackerQueueColRemove"><a href="javascript:void(0);" onclick="fixedPopup('<?php echo GFUrl::getUrl()->currentBaseURL('MyQueuePopup') ?>', 625, 180);"><img src="/images/plus.gif" alt="" border="0" /></a></td>
		</tr></table>
	</div>
	<div id="jsTrackerItemList"></div>
	<div id="jsSeparator" style="height:16px;"></div>
</div>
<div class="jsTrackerQueueSave" align="right"><?php echo HTMLWidget::button("submit","" .   $Lang->getText('TrackerMyQueue.SaveQueue') . " ","updateQueue","","")?></div>
</form>
</p>
</div>

<?php

// get the user projects to display in a tab
$user_projects = $User->getAllProjects();
echo '<div class="tabbertab'. ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='otherpending') ? ' tabbertabdefault' : '') .'" title="'. $Lang->getText('My.Pending') . '" id="otherpendingtab">'; 

$theader = array();
$theader[] = $Lang->getText('Project.Project');
$theader[] = $Lang->getText('My.Pending');
echo $template->tableTop($theader);
$nopending=true;


if (count($user_projects) > 0){
	$user_projects_ids = array();
	foreach ($user_projects as $user_project) {
		$user_projects_ids[] = $user_project->getProjectId();
	}
	// Retrieve the objects array
	$crit = new Criteria();
	$crit->add(ProjectJoinRequestPeer::PROJECT_ID, $user_projects_ids, Criteria::IN);
	$crit->setDistinct();
	$crit->addSelectColumn(ProjectJoinRequestPeer::PROJECT_ID);
	$rs = ProjectJoinRequestPeer::doSelectRS($crit);
	while ($rs->next()) {
		$join_req_id = $rs->getInt(1);
		$cols = array();
		foreach($user_projects as $project) {
			if($project->getProjectId()==$join_req_id && $project->userIsAdmin()) {
				$cols[] = '<a href="' . GFUrl::getUrl()->projectURL($project) . '" >' .  $project->getProjectName() . '</a>';
				$cols[] = '<a href="' . GFUrl::getUrl()->projectURL($project,'ProjectJoinRequestBrowse','','admin'). '" >'.$Lang->getText('ProjectJoinRequest.PendingRequests').'</a>';
				echo $template->tableRow($cols);
				$nopending=false;
				break;
			}
		}
	}
	
	if (Session::getSession()->isSiteAdmin()) {
		$crit = new Criteria();
		$crit->add(ProjectPeer::STATUS, Project::STATUS_PENDING);
		$pending_projects = ProjectPeer::doSelect($crit);
		foreach ($pending_projects as $pending_project) {
			$cols = array();
			$cols[] = $pending_project->getProjectName();
			$cols[] = '<a href="/gf/admin/?action=approve-pending">'.$Lang->getText('Project.PendingProjectApproval').'</a>';
			echo $template->tableRow($cols);
			$nopending = false;
		}
	}

	$pending_docs_projects = DocmanFilePeer::doSelectProjectsWithPendingDocs($user_projects_ids);
	
	foreach ($pending_docs_projects as $project_id) {
		foreach($user_projects as $project) {
			if($project->getProjectId()==$project_id && $project->getPermission()->check(DocmanPlugin::SECTION,0,DocmanPlugin::ADMIN)) {
				$cols = array();
				$cols[] = '<a href="' . GFUrl::getUrl()->projectURL($project) . '" >' .  $project->getProjectName() . '</a>';
				$cols[] = '<a href="' . GFUrl::getUrl()->projectURL($project,'','docman','admin'). '" >'.$Lang->getText('DocmanFolder.PendingDocs').'</a>';
				echo $template->tableRow($cols);
				$nopending=false;
				break;
			}
		}
	}

	//Start forum moderation pending messages
	$con = Propel::getConnection(ForumPeer::DATABASE_NAME);
	$stmt = $con->createStatement();

	$user = Session::getSession()->getUser();
	$project_ids = $user->getAllProjectIds();

	foreach ($project_ids as $project_id) {
		unset($project);
		$project = ProjectPeer::retrieveByPk($project_id);
		
		if (is_object($project)) {
			//If the user is site admin or project admin or forum plugin admin, gets to see the pending messages	
			if ($project->getPermission()->isAdmin() || $project->getPermission()->check(ForumPlugin::SECTION,0,ForumPlugin::ADMIN)) {
	
				$sql = "SELECT count(*) as messages FROM forum_message 
								WHERE is_approved = false AND
								forum_thread_id IN (
									SELECT forum_thread_id FROM forum_thread, forum 
									WHERE forum_thread.forum_id = forum.forum_id AND 
									forum.section = 'project' AND forum.ref_id = " . $project->getProjectId() . "
								)";
	
				$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);
				if ($rs != null && $rs->getRecordCount() > 0) {
					$rs->next();
					if ($rs->getInt('messages') > 0) {	
						$cols = array();
						$cols[] = '<a href="' . GFUrl::getUrl()->projectURL($project) . '" >' .  $project->getProjectName() . '</a>';
						$cols[] = '<a href="' . GFUrl::getUrl()->projectURL($project,'','forum','admin'). '" >'.$Lang->getText('Forum.PendingMessages').'</a>';
						echo $template->tableRow($cols);
						$nopending=false;
					}
				}		
				
			}
		}
	}
	//End forum moderation pending messages

}

if($nopending) {
	echo $template->tableFullRow($Lang->getText('My.NoPendingItems'));
}

echo $template->tableBottom();

?>
</div>

</div>
<div class="tabber">
<?php 

$params['theme'] = $template;

// get the tabs that the plugins for the user display
$prs = ActionManager::notify('BUILD_MYPAGE_ELEMENTS',$params);
foreach ($prs as $pr) {
	echo $pr->getResult();
}


echo '<div class="tabbertab'. ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='projects') ? ' tabbertabdefault' : '') .'" title="'. $Lang->getText('My.Projects') . '" id="projectstab">';
$theader = array();
$theader[] = $Lang->getText('My.MyProjects');
$theader[] = '&nbsp;';
echo $template->tableTop($theader);

if (count($user_projects) > 0){
	foreach ($user_projects as $user_project) {
		$cols = array();
		$project = $user_project;
		$cols[] = '<a href="' . GFUrl::getUrl()->projectURL($project) . '" >' .  $project->getProjectName() . '</a>';
		$cols[] = '<a href="' . GFUrl::getUrl()->currentBaseURL('UserProjectRemove', 
				array('project_id'=>$project->getProjectId())). '" >'.$Lang->getText('MyUserRemoveFromProject.Remove').'</a>';

		echo $template->tableRow($cols);
	}
	
} else { //The user have no projects.
	echo $template->tableFullRow($Lang->getText('My.NoProjects'));
}
echo $template->tableBottom();
echo '</div>';
?>
</div>
<script type="text/javascript">
Droppables.add('jsTrackerQueue', {accept:'jsTrackerItems', onDrop:addToQueue, hoverclass:'jsTrackerQueueActive'})
Sortable.create("jsTrackerItemList", {dropOnEmpty:true,containment:["jsTrackerItemList"], handle:'moveHandle', tag:'div',constraint:false,onUpdate:doBlockLink});
doPreviouslyQueued();
</script>
<?php
$template->footer();
?>

