<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Julian Yerfino jyerfino@gforgegroup.com
 * @date
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/MyTemplate.php');
require_once('lib/core/FilesystemPeer.php');
//require_once('lib/core/UserProjectPeer.php');
require_once('lib/html/HTMLWidget.php');
require_once('lib/core/MyReport.php');
require_once('lib/core/MyReportPeer.php');
require_once('lib/core/MyReportFieldFilter.php');
require_once('lib/core/MyReportFieldDisplay.php');
require_once('lib/core/MyReportFieldFilterPeer.php');
require_once('lib/core/MyReportFieldDisplayPeer.php');
require_once('lib/core/MyReportTracker.php');
require_once('lib/core/MyReportTrackerPeer.php');

/*class FakeTrackerExtraField extends BaseTrackerExtraField {
	
}*/

$session=Session::getSession();
if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$Lang = $session->getLanguage();
$template = new MyTemplate();
$user = Session::getSession()->getUser();

if(isset($_REQUEST['feedback'])) $feedback = $_REQUEST['feedback'];
if(isset($_REQUEST['report_id'])) {
	$report_id = Validator::sanitizeInt($_REQUEST['report_id']);
	// Fetch report data
	if($report_id != 0) {
		$report = MyReportPeer::retrieveByPK($report_id);
		if(!is_object($report)) {
			$is_new = true;
			$report_id = 0;
		}
		else {
			$is_new = false;
			if($report->getUserId() != $user->getUserId()) {
				$parms = array ('feedback'=>$Lang->getText('Report.NotOwner'));
				GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''), $parms);
				exit();
			}
		}
	}
	else {
		$is_new = true;
	}
}
else {
	$is_new = true;
	$report_id = 0;
}


if(!isset($_REQUEST['projects_selected']) || !is_array($_REQUEST['projects_selected']) || count($_REQUEST['projects_selected'])==0) {
	$_REQUEST['feedback'] = $Lang->getText('Report.ErrorNoProjectsSelected');
	include('ReportEditStep1.php');
	exit();
}

if(!isset($_REQUEST['trackers_selected']) || !is_array($_REQUEST['trackers_selected']) || count($_REQUEST['trackers_selected'])==0) {
	$_REQUEST['feedback'] = $Lang->getText('Report.ErrorNoTrackersSelected');
	include('ReportEditStep2.php');
	exit();
}

$params = array(
	'title' => $is_new ? Language::getSessText('Report.AddNew'):Language::getSessText('Report.Edit'),
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'action' => isset($action) ? $action : '',
	'selectedbottomtab' => 'myreports',
	'user' => $user,
	'extra_head' => array('<script language="javascript" type="text/javascript" src="/selectbox.js"></script>')
	);
$template->header($params);

echo '<p><div class="infobox">' . $Lang->getText('Report.Step3Description') . '</div></p><br>';

$params['theme'] = $template;

$projects_selected = array();
$trackers_selected = array();


// Build the list of selected projects, and from each project retrieve all trackers
// whose name matches one of the selected tracker names. From the trackers, extract the extra fields
// that appear in all trackers.


foreach($_REQUEST['projects_selected'] as $ps) {
	$ps = Validator::sanitizeInt($ps);
	$project = ProjectPeer::retrieveByPK($ps);
	if(is_object($project) && $project->userCanRead())
	{
		$projects_selected[$ps] = $project;
		
		$projectTrackers = $project->getTrackers();	
		foreach($projectTrackers as $pt) {
			if ($pt->userCanRead()) {
				foreach($_REQUEST['trackers_selected'] as $ts) {
					$ts = Validator::sanitizeString($ts);
					if($ts==$pt->getTrackerName()) {
						$trackers_selected[] = $pt;
						$efs = $pt->getTrackerExtraFields();
						$tmp_efs = array();
						foreach($efs as $ef)
						{
							$tmp_efs[$ef->getFieldName()] = $ef;
						}
						if(!isset($extrafields_arr)) {
							$extrafields_arr = $tmp_efs;
						}
						else {
								$extrafields_arr = array_intersect_key($extrafields_arr, $tmp_efs);
								foreach($extrafields_arr as $efname => $ef) {
									// If two fields match names but not types, they can't be used, remove them
									if($ef->getFieldType() != $tmp_efs[$efname]->getFieldType()) {
										unset($extrafields_arr[$efname]);
									}
								}
						}
						break;		
					}
				}
			}
		}
	}
}

// Leave only the name information in $extrafields_arr
$ef_arr = array();
foreach($extrafields_arr as $efname => $ef) {
	$ef_arr[$efname] = $efname;
}
$extrafields_arr = $ef_arr;


// Insert a bunch of 'fake' extra fields for the fixed sections of the tracker
$extrafields_arr[TrackerItemPeer::SUMMARY] = Language::getSessText('TrackerItem.SummaryName');
$extrafields_arr[TrackerItemPeer::DETAILS] = Language::getSessText('TrackerItem.DetailsName');
$extrafields_arr[TrackerItemPeer::PRIORITY] = Language::getSessText('TrackerItem.PriorityName');
$extrafields_arr[TrackerItemAssigneePeer::TABLE_NAME] = Language::getSessText('TrackerItem.AssignedTo');
$extrafields_filter_arr = $extrafields_arr;
$extrafields_arr[TrackerItemPeer::OPEN_DATE] = Language::getSessText('TrackerItem.OpenDateName');
$extrafields_arr[TrackerItemPeer::CLOSE_DATE] = Language::getSessText('TrackerItem.CloseDateName');
$extrafields_arr[TrackerItemPeer::LAST_MODIFIED_DATE] = Language::getSessText('TrackerItem.LastModifiedDateName');
$extrafields_arr[TrackerPeer::TRACKER_NAME] = Language::getSessText('Tracker.TabString');
$extrafields_arr[ProjectPeer::PROJECT_NAME] = Language::getSessText('Common.Project');

array_multisort($extrafields_arr, SORT_ASC);

$extrafields_filter_selected = array();
$extrafields_display_selected = array();

if(!$is_new) {
	// Fetch selected extra fields from the report
	$crit = new Criteria();
	$crit->add(MyReportFieldFilterPeer::MY_REPORT_ID, $report_id);
	/*$crit->addJoin(TrackerExtraFieldPeer::FIELD_NAME, MyReportFieldFilterPeer::FIELD_NAME);
	$crit->addJoin(TrackerPeer::TRACKER_ID, TrackerExtraFieldPeer::TRACKER_ID);
	$crit->addJoin(TrackerPeer::TRACKER_ID, MyReportTrackerPeer::TRACKER_ID);
	$crit->add(MyReportTrackerPeer::MY_REPORT_ID, $report_id);	
	$crit->addSelectColumn(TrackerExtraFieldPeer::FIELD_NAME);
	$crit->setDistinct();
	$rs = TrackerPeer::doSelectRS($crit);*/
	$crit->addSelectColumn(MyReportFieldFilterPeer::FIELD_NAME);
	$rs = MyReportFieldFilterPeer::doSelectRS($crit);
	while($rs->next())
	{
		$extrafields_filter_selected[] = $rs->getString(1);
	}
	
	$crit = new Criteria();
	$crit->add(MyReportFieldDisplayPeer::MY_REPORT_ID, $report_id);
	/*$crit->addJoin(TrackerExtraFieldPeer::FIELD_NAME, MyReportFieldDisplayPeer::FIELD_NAME);
	$crit->addJoin(TrackerPeer::TRACKER_ID, TrackerExtraFieldPeer::TRACKER_ID);
	$crit->addJoin(TrackerPeer::TRACKER_ID, MyReportTrackerPeer::TRACKER_ID);
	$crit->add(MyReportTrackerPeer::MY_REPORT_ID, $report_id);
	$crit->addSelectColumn(MyReportFieldDisplayPeer::COLUMN_ORDER);
	$crit->addSelectColumn(TrackerExtraFieldPeer::FIELD_NAME);
	$crit->setDistinct();
	$rs = TrackerPeer::doSelectRS($crit);*/
	$crit->addAscendingOrderByColumn(MyReportFieldDisplayPeer::COLUMN_ORDER);
	$crit->addSelectColumn(MyReportFieldDisplayPeer::FIELD_NAME);
	$rs = MyReportFieldDisplayPeer::doSelectRS($crit);
	while($rs->next())
	{
		$extrafields_display_selected[] = $rs->getString(1);
	}
	
}

$extrafields_display = array();
$extrafields_display_unselected_arr = array();

// This puts all selected fields in the appropiate order for displaying on the right side selection
foreach($extrafields_display_selected as $efsel) {
	if (array_key_exists($efsel,$extrafields_arr)!==false) {
		$extrafields_display[$efsel] = $extrafields_arr[$efsel];
	}
}

// This takes the non selected fields so they are displayed in the left side select box for selection
foreach($extrafields_arr as $efk => $efn) {
	if (array_search($efk, $extrafields_display_selected) === false)
	{
		$extrafields_display_unselected_arr[$efk] = $efn;
	}
}

include('forms/ReportEditStep3-tpl.php');

$template->footer();
?>
