<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for Association
//
require_once('core/AssociationPeer.php');
require_once('core/Association.php');
require_once('GFUrl.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('lib/html/ProjectTemplate.php');
$theme = new ProjectTemplate();

$project = GFUrl::getUrl()->getProject();

$params = array(
		'project' => $project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Association.AddNewPageTitle')
		);

$from_section=((isset($_POST['from_section'])) ? htmlspecialchars($_POST['from_section']) : htmlspecialchars($_GET['from_section']) );
$from_ref_id=((isset($_POST['from_ref_id'])) ? Validator::sanitizeInt($_POST['from_ref_id']) : Validator::sanitizeInt($_GET['from_ref_id']) );
$to_section=((isset($_POST['to_section'])) ? $_POST['to_section'] : '' );
$to_ref_id=((isset($_POST['to_ref_id'])) ? Validator::sanitizeInt($_POST['to_ref_id']) : '' );
$comment=((isset($_POST['comment'])) ? htmlspecialchars($_POST['comment']) : '' );

if (isset($_POST['return_to'])){
	if (Validator::validateRedirect($_POST['return_to'])) {
		$return_to = $_POST['return_to']; 
	}else{
		throw new PermissionDeniedException;
	}
}elseif (isset($_GET['return_to'])) {
	if (Validator::validateRedirect($_GET['return_to'])) {
		$return_to = $_GET['return_to'];
	}else{
		throw new PermissionDeniedException('Invalid URL');
	}
}else{
	$return_to='';
}
$return_to = preg_replace("/&feedback=.*$/", "", $return_to);


echo $theme->header($params);

include('forms/AssociationAdd-tpl.php');

?>
